package com.bureau.behavioralbiometrics.data.local;

import androidx.annotation.NonNull;
import androidx.room.DatabaseConfiguration;
import androidx.room.InvalidationTracker;
import androidx.room.RoomOpenHelper;
import androidx.room.RoomOpenHelper.Delegate;
import androidx.room.RoomOpenHelper.ValidationResult;
import androidx.room.migration.AutoMigrationSpec;
import androidx.room.migration.Migration;
import androidx.room.util.DBUtil;
import androidx.room.util.TableInfo;
import androidx.room.util.TableInfo.Column;
import androidx.room.util.TableInfo.ForeignKey;
import androidx.room.util.TableInfo.Index;
import androidx.sqlite.db.SupportSQLiteDatabase;
import androidx.sqlite.db.SupportSQLiteOpenHelper;
import androidx.sqlite.db.SupportSQLiteOpenHelper.Callback;
import androidx.sqlite.db.SupportSQLiteOpenHelper.Configuration;
import com.bureau.behavioralbiometrics.data.local.dao.BBDao;
import com.bureau.behavioralbiometrics.data.local.dao.BBDao_Impl;
import java.lang.Class;
import java.lang.Override;
import java.lang.String;
import java.lang.SuppressWarnings;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

@SuppressWarnings({"unchecked", "deprecation"})
public final class BBDatabase_Impl extends BBDatabase {
  private volatile BBDao _bBDao;

  @Override
  protected SupportSQLiteOpenHelper createOpenHelper(DatabaseConfiguration configuration) {
    final SupportSQLiteOpenHelper.Callback _openCallback = new RoomOpenHelper(configuration, new RoomOpenHelper.Delegate(1) {
      @Override
      public void createAllTables(SupportSQLiteDatabase _db) {
        _db.execSQL("CREATE TABLE IF NOT EXISTS `app_life_cycle_events` (`id` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `timeStamp` INTEGER NOT NULL, `appLifecycleStatus` TEXT NOT NULL)");
        _db.execSQL("CREATE TABLE IF NOT EXISTS `touch_type_data` (`id` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `timeStamp` INTEGER NOT NULL, `touchToolType` TEXT NOT NULL, `deviceId` INTEGER NOT NULL, `pressure` REAL NOT NULL, `radiusMajor` REAL NOT NULL, `radiusMinor` REAL NOT NULL, `orientation` REAL NOT NULL, `gesture` TEXT NOT NULL, `offset2D_xOffset` REAL NOT NULL, `offset2D_yOffset` REAL NOT NULL, `position2D_xPosition` REAL NOT NULL, `position2D_yPosition` REAL NOT NULL, `pressureRange_lowerBound` REAL NOT NULL, `pressureRange_upperBound` REAL NOT NULL, `targetElement_targetId` TEXT NOT NULL, `targetElement_targetType` TEXT NOT NULL)");
        _db.execSQL("CREATE TABLE IF NOT EXISTS `key_press_data_table` (`id` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `timeStamp` INTEGER NOT NULL, `keyPressType` TEXT NOT NULL, `maskedKey` INTEGER NOT NULL, `targetElement_targetId` TEXT NOT NULL, `targetElement_targetType` TEXT NOT NULL)");
        _db.execSQL("CREATE TABLE IF NOT EXISTS `input_change_data_table` (`id` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `timeStamp` INTEGER NOT NULL, `focus` INTEGER NOT NULL, `maskedText` TEXT NOT NULL, `inputChangeAction` TEXT NOT NULL, `targetElement_targetId` TEXT NOT NULL, `targetElement_targetType` TEXT NOT NULL)");
        _db.execSQL("CREATE TABLE IF NOT EXISTS `focus_change_data_table` (`id` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `timeStamp` INTEGER NOT NULL, `focusChangeType` TEXT NOT NULL, `targetElement_targetId` TEXT NOT NULL, `targetElement_targetType` TEXT NOT NULL)");
        _db.execSQL("CREATE TABLE IF NOT EXISTS `view_port_scroll_data_table` (`id` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `timeStamp` INTEGER NOT NULL, `deltaX` INTEGER NOT NULL, `deltaY` INTEGER NOT NULL, `targetElement_targetId` TEXT NOT NULL, `targetElement_targetType` TEXT NOT NULL)");
        _db.execSQL("CREATE TABLE IF NOT EXISTS `frame_rate_event_table` (`id` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `timeStamp` INTEGER NOT NULL, `frameRate` REAL NOT NULL)");
        _db.execSQL("CREATE TABLE IF NOT EXISTS `accelerometer_data` (`id` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `timeStamp` INTEGER NOT NULL, `xAcc` REAL NOT NULL, `yAcc` REAL NOT NULL, `zAcc` REAL NOT NULL)");
        _db.execSQL("CREATE TABLE IF NOT EXISTS `gyroscope_data` (`id` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, `timeStamp` INTEGER NOT NULL, `xRot` REAL NOT NULL, `yRot` REAL NOT NULL, `zRot` REAL NOT NULL)");
        _db.execSQL("CREATE TABLE IF NOT EXISTS room_master_table (id INTEGER PRIMARY KEY,identity_hash TEXT)");
        _db.execSQL("INSERT OR REPLACE INTO room_master_table (id,identity_hash) VALUES(42, '3cdece5bd473a9209b229fdc73c734cc')");
      }

      @Override
      public void dropAllTables(SupportSQLiteDatabase _db) {
        _db.execSQL("DROP TABLE IF EXISTS `app_life_cycle_events`");
        _db.execSQL("DROP TABLE IF EXISTS `touch_type_data`");
        _db.execSQL("DROP TABLE IF EXISTS `key_press_data_table`");
        _db.execSQL("DROP TABLE IF EXISTS `input_change_data_table`");
        _db.execSQL("DROP TABLE IF EXISTS `focus_change_data_table`");
        _db.execSQL("DROP TABLE IF EXISTS `view_port_scroll_data_table`");
        _db.execSQL("DROP TABLE IF EXISTS `frame_rate_event_table`");
        _db.execSQL("DROP TABLE IF EXISTS `accelerometer_data`");
        _db.execSQL("DROP TABLE IF EXISTS `gyroscope_data`");
        if (mCallbacks != null) {
          for (int _i = 0, _size = mCallbacks.size(); _i < _size; _i++) {
            mCallbacks.get(_i).onDestructiveMigration(_db);
          }
        }
      }

      @Override
      public void onCreate(SupportSQLiteDatabase _db) {
        if (mCallbacks != null) {
          for (int _i = 0, _size = mCallbacks.size(); _i < _size; _i++) {
            mCallbacks.get(_i).onCreate(_db);
          }
        }
      }

      @Override
      public void onOpen(SupportSQLiteDatabase _db) {
        mDatabase = _db;
        internalInitInvalidationTracker(_db);
        if (mCallbacks != null) {
          for (int _i = 0, _size = mCallbacks.size(); _i < _size; _i++) {
            mCallbacks.get(_i).onOpen(_db);
          }
        }
      }

      @Override
      public void onPreMigrate(SupportSQLiteDatabase _db) {
        DBUtil.dropFtsSyncTriggers(_db);
      }

      @Override
      public void onPostMigrate(SupportSQLiteDatabase _db) {
      }

      @Override
      public RoomOpenHelper.ValidationResult onValidateSchema(SupportSQLiteDatabase _db) {
        final HashMap<String, TableInfo.Column> _columnsAppLifeCycleEvents = new HashMap<String, TableInfo.Column>(3);
        _columnsAppLifeCycleEvents.put("id", new TableInfo.Column("id", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsAppLifeCycleEvents.put("timeStamp", new TableInfo.Column("timeStamp", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsAppLifeCycleEvents.put("appLifecycleStatus", new TableInfo.Column("appLifecycleStatus", "TEXT", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysAppLifeCycleEvents = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesAppLifeCycleEvents = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoAppLifeCycleEvents = new TableInfo("app_life_cycle_events", _columnsAppLifeCycleEvents, _foreignKeysAppLifeCycleEvents, _indicesAppLifeCycleEvents);
        final TableInfo _existingAppLifeCycleEvents = TableInfo.read(_db, "app_life_cycle_events");
        if (! _infoAppLifeCycleEvents.equals(_existingAppLifeCycleEvents)) {
          return new RoomOpenHelper.ValidationResult(false, "app_life_cycle_events(com.bureau.behavioralbiometrics.applifecycleevents.models.AppLifecycleEventLocal).\n"
                  + " Expected:\n" + _infoAppLifeCycleEvents + "\n"
                  + " Found:\n" + _existingAppLifeCycleEvents);
        }
        final HashMap<String, TableInfo.Column> _columnsTouchTypeData = new HashMap<String, TableInfo.Column>(17);
        _columnsTouchTypeData.put("id", new TableInfo.Column("id", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsTouchTypeData.put("timeStamp", new TableInfo.Column("timeStamp", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsTouchTypeData.put("touchToolType", new TableInfo.Column("touchToolType", "TEXT", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsTouchTypeData.put("deviceId", new TableInfo.Column("deviceId", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsTouchTypeData.put("pressure", new TableInfo.Column("pressure", "REAL", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsTouchTypeData.put("radiusMajor", new TableInfo.Column("radiusMajor", "REAL", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsTouchTypeData.put("radiusMinor", new TableInfo.Column("radiusMinor", "REAL", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsTouchTypeData.put("orientation", new TableInfo.Column("orientation", "REAL", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsTouchTypeData.put("gesture", new TableInfo.Column("gesture", "TEXT", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsTouchTypeData.put("offset2D_xOffset", new TableInfo.Column("offset2D_xOffset", "REAL", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsTouchTypeData.put("offset2D_yOffset", new TableInfo.Column("offset2D_yOffset", "REAL", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsTouchTypeData.put("position2D_xPosition", new TableInfo.Column("position2D_xPosition", "REAL", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsTouchTypeData.put("position2D_yPosition", new TableInfo.Column("position2D_yPosition", "REAL", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsTouchTypeData.put("pressureRange_lowerBound", new TableInfo.Column("pressureRange_lowerBound", "REAL", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsTouchTypeData.put("pressureRange_upperBound", new TableInfo.Column("pressureRange_upperBound", "REAL", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsTouchTypeData.put("targetElement_targetId", new TableInfo.Column("targetElement_targetId", "TEXT", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsTouchTypeData.put("targetElement_targetType", new TableInfo.Column("targetElement_targetType", "TEXT", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysTouchTypeData = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesTouchTypeData = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoTouchTypeData = new TableInfo("touch_type_data", _columnsTouchTypeData, _foreignKeysTouchTypeData, _indicesTouchTypeData);
        final TableInfo _existingTouchTypeData = TableInfo.read(_db, "touch_type_data");
        if (! _infoTouchTypeData.equals(_existingTouchTypeData)) {
          return new RoomOpenHelper.ValidationResult(false, "touch_type_data(com.bureau.behavioralbiometrics.touchtypedata.models.TouchTypeDataLocal).\n"
                  + " Expected:\n" + _infoTouchTypeData + "\n"
                  + " Found:\n" + _existingTouchTypeData);
        }
        final HashMap<String, TableInfo.Column> _columnsKeyPressDataTable = new HashMap<String, TableInfo.Column>(6);
        _columnsKeyPressDataTable.put("id", new TableInfo.Column("id", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsKeyPressDataTable.put("timeStamp", new TableInfo.Column("timeStamp", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsKeyPressDataTable.put("keyPressType", new TableInfo.Column("keyPressType", "TEXT", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsKeyPressDataTable.put("maskedKey", new TableInfo.Column("maskedKey", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsKeyPressDataTable.put("targetElement_targetId", new TableInfo.Column("targetElement_targetId", "TEXT", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsKeyPressDataTable.put("targetElement_targetType", new TableInfo.Column("targetElement_targetType", "TEXT", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysKeyPressDataTable = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesKeyPressDataTable = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoKeyPressDataTable = new TableInfo("key_press_data_table", _columnsKeyPressDataTable, _foreignKeysKeyPressDataTable, _indicesKeyPressDataTable);
        final TableInfo _existingKeyPressDataTable = TableInfo.read(_db, "key_press_data_table");
        if (! _infoKeyPressDataTable.equals(_existingKeyPressDataTable)) {
          return new RoomOpenHelper.ValidationResult(false, "key_press_data_table(com.bureau.behavioralbiometrics.keypressTypedata.models.KeyPressEventLocal).\n"
                  + " Expected:\n" + _infoKeyPressDataTable + "\n"
                  + " Found:\n" + _existingKeyPressDataTable);
        }
        final HashMap<String, TableInfo.Column> _columnsInputChangeDataTable = new HashMap<String, TableInfo.Column>(7);
        _columnsInputChangeDataTable.put("id", new TableInfo.Column("id", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsInputChangeDataTable.put("timeStamp", new TableInfo.Column("timeStamp", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsInputChangeDataTable.put("focus", new TableInfo.Column("focus", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsInputChangeDataTable.put("maskedText", new TableInfo.Column("maskedText", "TEXT", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsInputChangeDataTable.put("inputChangeAction", new TableInfo.Column("inputChangeAction", "TEXT", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsInputChangeDataTable.put("targetElement_targetId", new TableInfo.Column("targetElement_targetId", "TEXT", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsInputChangeDataTable.put("targetElement_targetType", new TableInfo.Column("targetElement_targetType", "TEXT", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysInputChangeDataTable = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesInputChangeDataTable = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoInputChangeDataTable = new TableInfo("input_change_data_table", _columnsInputChangeDataTable, _foreignKeysInputChangeDataTable, _indicesInputChangeDataTable);
        final TableInfo _existingInputChangeDataTable = TableInfo.read(_db, "input_change_data_table");
        if (! _infoInputChangeDataTable.equals(_existingInputChangeDataTable)) {
          return new RoomOpenHelper.ValidationResult(false, "input_change_data_table(com.bureau.behavioralbiometrics.keypressTypedata.models.InputChangeEventLocal).\n"
                  + " Expected:\n" + _infoInputChangeDataTable + "\n"
                  + " Found:\n" + _existingInputChangeDataTable);
        }
        final HashMap<String, TableInfo.Column> _columnsFocusChangeDataTable = new HashMap<String, TableInfo.Column>(5);
        _columnsFocusChangeDataTable.put("id", new TableInfo.Column("id", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsFocusChangeDataTable.put("timeStamp", new TableInfo.Column("timeStamp", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsFocusChangeDataTable.put("focusChangeType", new TableInfo.Column("focusChangeType", "TEXT", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsFocusChangeDataTable.put("targetElement_targetId", new TableInfo.Column("targetElement_targetId", "TEXT", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsFocusChangeDataTable.put("targetElement_targetType", new TableInfo.Column("targetElement_targetType", "TEXT", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysFocusChangeDataTable = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesFocusChangeDataTable = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoFocusChangeDataTable = new TableInfo("focus_change_data_table", _columnsFocusChangeDataTable, _foreignKeysFocusChangeDataTable, _indicesFocusChangeDataTable);
        final TableInfo _existingFocusChangeDataTable = TableInfo.read(_db, "focus_change_data_table");
        if (! _infoFocusChangeDataTable.equals(_existingFocusChangeDataTable)) {
          return new RoomOpenHelper.ValidationResult(false, "focus_change_data_table(com.bureau.behavioralbiometrics.focuschangedata.models.FocusChangeDataLocal).\n"
                  + " Expected:\n" + _infoFocusChangeDataTable + "\n"
                  + " Found:\n" + _existingFocusChangeDataTable);
        }
        final HashMap<String, TableInfo.Column> _columnsViewPortScrollDataTable = new HashMap<String, TableInfo.Column>(6);
        _columnsViewPortScrollDataTable.put("id", new TableInfo.Column("id", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsViewPortScrollDataTable.put("timeStamp", new TableInfo.Column("timeStamp", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsViewPortScrollDataTable.put("deltaX", new TableInfo.Column("deltaX", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsViewPortScrollDataTable.put("deltaY", new TableInfo.Column("deltaY", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsViewPortScrollDataTable.put("targetElement_targetId", new TableInfo.Column("targetElement_targetId", "TEXT", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsViewPortScrollDataTable.put("targetElement_targetType", new TableInfo.Column("targetElement_targetType", "TEXT", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysViewPortScrollDataTable = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesViewPortScrollDataTable = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoViewPortScrollDataTable = new TableInfo("view_port_scroll_data_table", _columnsViewPortScrollDataTable, _foreignKeysViewPortScrollDataTable, _indicesViewPortScrollDataTable);
        final TableInfo _existingViewPortScrollDataTable = TableInfo.read(_db, "view_port_scroll_data_table");
        if (! _infoViewPortScrollDataTable.equals(_existingViewPortScrollDataTable)) {
          return new RoomOpenHelper.ValidationResult(false, "view_port_scroll_data_table(com.bureau.behavioralbiometrics.touchtypedata.models.ViewPortScrollDataLocal).\n"
                  + " Expected:\n" + _infoViewPortScrollDataTable + "\n"
                  + " Found:\n" + _existingViewPortScrollDataTable);
        }
        final HashMap<String, TableInfo.Column> _columnsFrameRateEventTable = new HashMap<String, TableInfo.Column>(3);
        _columnsFrameRateEventTable.put("id", new TableInfo.Column("id", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsFrameRateEventTable.put("timeStamp", new TableInfo.Column("timeStamp", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsFrameRateEventTable.put("frameRate", new TableInfo.Column("frameRate", "REAL", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysFrameRateEventTable = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesFrameRateEventTable = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoFrameRateEventTable = new TableInfo("frame_rate_event_table", _columnsFrameRateEventTable, _foreignKeysFrameRateEventTable, _indicesFrameRateEventTable);
        final TableInfo _existingFrameRateEventTable = TableInfo.read(_db, "frame_rate_event_table");
        if (! _infoFrameRateEventTable.equals(_existingFrameRateEventTable)) {
          return new RoomOpenHelper.ValidationResult(false, "frame_rate_event_table(com.bureau.behavioralbiometrics.frameratecollection.models.FrameRateEventLocal).\n"
                  + " Expected:\n" + _infoFrameRateEventTable + "\n"
                  + " Found:\n" + _existingFrameRateEventTable);
        }
        final HashMap<String, TableInfo.Column> _columnsAccelerometerData = new HashMap<String, TableInfo.Column>(5);
        _columnsAccelerometerData.put("id", new TableInfo.Column("id", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsAccelerometerData.put("timeStamp", new TableInfo.Column("timeStamp", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsAccelerometerData.put("xAcc", new TableInfo.Column("xAcc", "REAL", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsAccelerometerData.put("yAcc", new TableInfo.Column("yAcc", "REAL", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsAccelerometerData.put("zAcc", new TableInfo.Column("zAcc", "REAL", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysAccelerometerData = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesAccelerometerData = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoAccelerometerData = new TableInfo("accelerometer_data", _columnsAccelerometerData, _foreignKeysAccelerometerData, _indicesAccelerometerData);
        final TableInfo _existingAccelerometerData = TableInfo.read(_db, "accelerometer_data");
        if (! _infoAccelerometerData.equals(_existingAccelerometerData)) {
          return new RoomOpenHelper.ValidationResult(false, "accelerometer_data(com.bureau.behavioralbiometrics.sensordata.models.AccelerometerDataLocal).\n"
                  + " Expected:\n" + _infoAccelerometerData + "\n"
                  + " Found:\n" + _existingAccelerometerData);
        }
        final HashMap<String, TableInfo.Column> _columnsGyroscopeData = new HashMap<String, TableInfo.Column>(5);
        _columnsGyroscopeData.put("id", new TableInfo.Column("id", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsGyroscopeData.put("timeStamp", new TableInfo.Column("timeStamp", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsGyroscopeData.put("xRot", new TableInfo.Column("xRot", "REAL", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsGyroscopeData.put("yRot", new TableInfo.Column("yRot", "REAL", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsGyroscopeData.put("zRot", new TableInfo.Column("zRot", "REAL", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysGyroscopeData = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesGyroscopeData = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoGyroscopeData = new TableInfo("gyroscope_data", _columnsGyroscopeData, _foreignKeysGyroscopeData, _indicesGyroscopeData);
        final TableInfo _existingGyroscopeData = TableInfo.read(_db, "gyroscope_data");
        if (! _infoGyroscopeData.equals(_existingGyroscopeData)) {
          return new RoomOpenHelper.ValidationResult(false, "gyroscope_data(com.bureau.behavioralbiometrics.sensordata.models.GyroscopeDataLocal).\n"
                  + " Expected:\n" + _infoGyroscopeData + "\n"
                  + " Found:\n" + _existingGyroscopeData);
        }
        return new RoomOpenHelper.ValidationResult(true, null);
      }
    }, "3cdece5bd473a9209b229fdc73c734cc", "98be51e57ff3df96ba79e92b8e2f4e0a");
    final SupportSQLiteOpenHelper.Configuration _sqliteConfig = SupportSQLiteOpenHelper.Configuration.builder(configuration.context)
        .name(configuration.name)
        .callback(_openCallback)
        .build();
    final SupportSQLiteOpenHelper _helper = configuration.sqliteOpenHelperFactory.create(_sqliteConfig);
    return _helper;
  }

  @Override
  protected InvalidationTracker createInvalidationTracker() {
    final HashMap<String, String> _shadowTablesMap = new HashMap<String, String>(0);
    HashMap<String, Set<String>> _viewTables = new HashMap<String, Set<String>>(0);
    return new InvalidationTracker(this, _shadowTablesMap, _viewTables, "app_life_cycle_events","touch_type_data","key_press_data_table","input_change_data_table","focus_change_data_table","view_port_scroll_data_table","frame_rate_event_table","accelerometer_data","gyroscope_data");
  }

  @Override
  public void clearAllTables() {
    super.assertNotMainThread();
    final SupportSQLiteDatabase _db = super.getOpenHelper().getWritableDatabase();
    try {
      super.beginTransaction();
      _db.execSQL("DELETE FROM `app_life_cycle_events`");
      _db.execSQL("DELETE FROM `touch_type_data`");
      _db.execSQL("DELETE FROM `key_press_data_table`");
      _db.execSQL("DELETE FROM `input_change_data_table`");
      _db.execSQL("DELETE FROM `focus_change_data_table`");
      _db.execSQL("DELETE FROM `view_port_scroll_data_table`");
      _db.execSQL("DELETE FROM `frame_rate_event_table`");
      _db.execSQL("DELETE FROM `accelerometer_data`");
      _db.execSQL("DELETE FROM `gyroscope_data`");
      super.setTransactionSuccessful();
    } finally {
      super.endTransaction();
      _db.query("PRAGMA wal_checkpoint(FULL)").close();
      if (!_db.inTransaction()) {
        _db.execSQL("VACUUM");
      }
    }
  }

  @Override
  protected Map<Class<?>, List<Class<?>>> getRequiredTypeConverters() {
    final HashMap<Class<?>, List<Class<?>>> _typeConvertersMap = new HashMap<Class<?>, List<Class<?>>>();
    _typeConvertersMap.put(BBDao.class, BBDao_Impl.getRequiredConverters());
    return _typeConvertersMap;
  }

  @Override
  public Set<Class<? extends AutoMigrationSpec>> getRequiredAutoMigrationSpecs() {
    final HashSet<Class<? extends AutoMigrationSpec>> _autoMigrationSpecsSet = new HashSet<Class<? extends AutoMigrationSpec>>();
    return _autoMigrationSpecsSet;
  }

  @Override
  public List<Migration> getAutoMigrations(
      @NonNull Map<Class<? extends AutoMigrationSpec>, AutoMigrationSpec> autoMigrationSpecsMap) {
    return Arrays.asList();
  }

  @Override
  public BBDao bbDao() {
    if (_bBDao != null) {
      return _bBDao;
    } else {
      synchronized(this) {
        if(_bBDao == null) {
          _bBDao = new BBDao_Impl(this);
        }
        return _bBDao;
      }
    }
  }
}
