package com.bureau.behavioralbiometrics.data.local.dao;

import android.database.Cursor;
import androidx.room.CoroutinesRoom;
import androidx.room.EntityDeletionOrUpdateAdapter;
import androidx.room.EntityInsertionAdapter;
import androidx.room.RoomDatabase;
import androidx.room.RoomSQLiteQuery;
import androidx.room.SharedSQLiteStatement;
import androidx.room.util.CursorUtil;
import androidx.room.util.DBUtil;
import androidx.sqlite.db.SupportSQLiteStatement;
import com.bureau.behavioralbiometrics.applifecycleevents.models.AppLifecycleEventLocal;
import com.bureau.behavioralbiometrics.applifecycleevents.models.AppLifecycleStatus;
import com.bureau.behavioralbiometrics.focuschangedata.models.FocusChangeDataLocal;
import com.bureau.behavioralbiometrics.focuschangedata.models.FocusChangeType;
import com.bureau.behavioralbiometrics.frameratecollection.models.FrameRateEventLocal;
import com.bureau.behavioralbiometrics.keypressTypedata.models.InputChangeAction;
import com.bureau.behavioralbiometrics.keypressTypedata.models.InputChangeEventLocal;
import com.bureau.behavioralbiometrics.keypressTypedata.models.KeyPressEventLocal;
import com.bureau.behavioralbiometrics.keypressTypedata.models.KeyPressType;
import com.bureau.behavioralbiometrics.models.TargetElement;
import com.bureau.behavioralbiometrics.sensordata.models.AccelerometerDataLocal;
import com.bureau.behavioralbiometrics.sensordata.models.GyroscopeDataLocal;
import com.bureau.behavioralbiometrics.touchtypedata.models.ClosedRange;
import com.bureau.behavioralbiometrics.touchtypedata.models.Gesture;
import com.bureau.behavioralbiometrics.touchtypedata.models.Offset2D;
import com.bureau.behavioralbiometrics.touchtypedata.models.Position2D;
import com.bureau.behavioralbiometrics.touchtypedata.models.TouchToolType;
import com.bureau.behavioralbiometrics.touchtypedata.models.TouchTypeDataLocal;
import com.bureau.behavioralbiometrics.touchtypedata.models.ViewPortScrollDataLocal;
import java.lang.Class;
import java.lang.Exception;
import java.lang.IllegalArgumentException;
import java.lang.Object;
import java.lang.Override;
import java.lang.String;
import java.lang.SuppressWarnings;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.concurrent.Callable;
import kotlin.Unit;
import kotlin.coroutines.Continuation;
import kotlinx.coroutines.flow.Flow;

@SuppressWarnings({"unchecked", "deprecation"})
public final class BBDao_Impl implements BBDao {
  private final RoomDatabase __db;

  private final EntityInsertionAdapter<AppLifecycleEventLocal> __insertionAdapterOfAppLifecycleEventLocal;

  private final EntityInsertionAdapter<AppLifecycleEventLocal> __insertionAdapterOfAppLifecycleEventLocal_1;

  private final EntityInsertionAdapter<TouchTypeDataLocal> __insertionAdapterOfTouchTypeDataLocal;

  private final EntityInsertionAdapter<TouchTypeDataLocal> __insertionAdapterOfTouchTypeDataLocal_1;

  private final EntityInsertionAdapter<KeyPressEventLocal> __insertionAdapterOfKeyPressEventLocal;

  private final EntityInsertionAdapter<KeyPressEventLocal> __insertionAdapterOfKeyPressEventLocal_1;

  private final EntityInsertionAdapter<InputChangeEventLocal> __insertionAdapterOfInputChangeEventLocal;

  private final EntityInsertionAdapter<InputChangeEventLocal> __insertionAdapterOfInputChangeEventLocal_1;

  private final EntityInsertionAdapter<FocusChangeDataLocal> __insertionAdapterOfFocusChangeDataLocal;

  private final EntityInsertionAdapter<FocusChangeDataLocal> __insertionAdapterOfFocusChangeDataLocal_1;

  private final EntityInsertionAdapter<ViewPortScrollDataLocal> __insertionAdapterOfViewPortScrollDataLocal;

  private final EntityInsertionAdapter<ViewPortScrollDataLocal> __insertionAdapterOfViewPortScrollDataLocal_1;

  private final EntityInsertionAdapter<FrameRateEventLocal> __insertionAdapterOfFrameRateEventLocal;

  private final EntityInsertionAdapter<FrameRateEventLocal> __insertionAdapterOfFrameRateEventLocal_1;

  private final EntityInsertionAdapter<AccelerometerDataLocal> __insertionAdapterOfAccelerometerDataLocal;

  private final EntityInsertionAdapter<AccelerometerDataLocal> __insertionAdapterOfAccelerometerDataLocal_1;

  private final EntityInsertionAdapter<GyroscopeDataLocal> __insertionAdapterOfGyroscopeDataLocal;

  private final EntityInsertionAdapter<GyroscopeDataLocal> __insertionAdapterOfGyroscopeDataLocal_1;

  private final EntityDeletionOrUpdateAdapter<AppLifecycleEventLocal> __deletionAdapterOfAppLifecycleEventLocal;

  private final EntityDeletionOrUpdateAdapter<TouchTypeDataLocal> __deletionAdapterOfTouchTypeDataLocal;

  private final EntityDeletionOrUpdateAdapter<KeyPressEventLocal> __deletionAdapterOfKeyPressEventLocal;

  private final EntityDeletionOrUpdateAdapter<InputChangeEventLocal> __deletionAdapterOfInputChangeEventLocal;

  private final EntityDeletionOrUpdateAdapter<FocusChangeDataLocal> __deletionAdapterOfFocusChangeDataLocal;

  private final EntityDeletionOrUpdateAdapter<ViewPortScrollDataLocal> __deletionAdapterOfViewPortScrollDataLocal;

  private final EntityDeletionOrUpdateAdapter<FrameRateEventLocal> __deletionAdapterOfFrameRateEventLocal;

  private final EntityDeletionOrUpdateAdapter<AccelerometerDataLocal> __deletionAdapterOfAccelerometerDataLocal;

  private final EntityDeletionOrUpdateAdapter<GyroscopeDataLocal> __deletionAdapterOfGyroscopeDataLocal;

  private final SharedSQLiteStatement __preparedStmtOfDeleteAllAppLifecycleEvents;

  private final SharedSQLiteStatement __preparedStmtOfDeleteAllTouchTypeData;

  private final SharedSQLiteStatement __preparedStmtOfDeleteAllKeyPressEvent;

  private final SharedSQLiteStatement __preparedStmtOfDeleteAllInputChangeEvent;

  private final SharedSQLiteStatement __preparedStmtOfDeleteAllFocusChangeData;

  private final SharedSQLiteStatement __preparedStmtOfDeleteAllViewPortScrollData;

  private final SharedSQLiteStatement __preparedStmtOfDeleteAllFrameRateEvent;

  private final SharedSQLiteStatement __preparedStmtOfDeleteAllAccelerometerData;

  private final SharedSQLiteStatement __preparedStmtOfDeleteAllGyroscopeData;

  public BBDao_Impl(RoomDatabase __db) {
    this.__db = __db;
    this.__insertionAdapterOfAppLifecycleEventLocal = new EntityInsertionAdapter<AppLifecycleEventLocal>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR ABORT INTO `app_life_cycle_events` (`id`,`timeStamp`,`appLifecycleStatus`) VALUES (nullif(?, 0),?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, AppLifecycleEventLocal value) {
        stmt.bindLong(1, value.getId());
        stmt.bindLong(2, value.getTimeStamp());
        if (value.getAppLifecycleStatus() == null) {
          stmt.bindNull(3);
        } else {
          stmt.bindString(3, __AppLifecycleStatus_enumToString(value.getAppLifecycleStatus()));
        }
      }
    };
    this.__insertionAdapterOfAppLifecycleEventLocal_1 = new EntityInsertionAdapter<AppLifecycleEventLocal>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR REPLACE INTO `app_life_cycle_events` (`id`,`timeStamp`,`appLifecycleStatus`) VALUES (nullif(?, 0),?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, AppLifecycleEventLocal value) {
        stmt.bindLong(1, value.getId());
        stmt.bindLong(2, value.getTimeStamp());
        if (value.getAppLifecycleStatus() == null) {
          stmt.bindNull(3);
        } else {
          stmt.bindString(3, __AppLifecycleStatus_enumToString(value.getAppLifecycleStatus()));
        }
      }
    };
    this.__insertionAdapterOfTouchTypeDataLocal = new EntityInsertionAdapter<TouchTypeDataLocal>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR ABORT INTO `touch_type_data` (`id`,`timeStamp`,`touchToolType`,`deviceId`,`pressure`,`radiusMajor`,`radiusMinor`,`orientation`,`gesture`,`offset2D_xOffset`,`offset2D_yOffset`,`position2D_xPosition`,`position2D_yPosition`,`pressureRange_lowerBound`,`pressureRange_upperBound`,`targetElement_targetId`,`targetElement_targetType`) VALUES (nullif(?, 0),?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, TouchTypeDataLocal value) {
        stmt.bindLong(1, value.getId());
        stmt.bindLong(2, value.getTimeStamp());
        if (value.getTouchToolType() == null) {
          stmt.bindNull(3);
        } else {
          stmt.bindString(3, __TouchToolType_enumToString(value.getTouchToolType()));
        }
        stmt.bindLong(4, value.getDeviceId());
        stmt.bindDouble(5, value.getPressure());
        stmt.bindDouble(6, value.getRadiusMajor());
        stmt.bindDouble(7, value.getRadiusMinor());
        stmt.bindDouble(8, value.getOrientation());
        if (value.getGesture() == null) {
          stmt.bindNull(9);
        } else {
          stmt.bindString(9, __Gesture_enumToString(value.getGesture()));
        }
        final Offset2D _tmpOffset2D = value.getOffset2D();
        if (_tmpOffset2D != null) {
          stmt.bindDouble(10, _tmpOffset2D.getXOffset());
          stmt.bindDouble(11, _tmpOffset2D.getYOffset());
        } else {
          stmt.bindNull(10);
          stmt.bindNull(11);
        }
        final Position2D _tmpPosition2D = value.getPosition2D();
        if (_tmpPosition2D != null) {
          stmt.bindDouble(12, _tmpPosition2D.getXPosition());
          stmt.bindDouble(13, _tmpPosition2D.getYPosition());
        } else {
          stmt.bindNull(12);
          stmt.bindNull(13);
        }
        final ClosedRange _tmpPressureRange = value.getPressureRange();
        if (_tmpPressureRange != null) {
          stmt.bindDouble(14, _tmpPressureRange.getLowerBound());
          stmt.bindDouble(15, _tmpPressureRange.getUpperBound());
        } else {
          stmt.bindNull(14);
          stmt.bindNull(15);
        }
        final TargetElement _tmpTargetElement = value.getTargetElement();
        if (_tmpTargetElement != null) {
          if (_tmpTargetElement.getTargetId() == null) {
            stmt.bindNull(16);
          } else {
            stmt.bindString(16, _tmpTargetElement.getTargetId());
          }
          if (_tmpTargetElement.getTargetType() == null) {
            stmt.bindNull(17);
          } else {
            stmt.bindString(17, _tmpTargetElement.getTargetType());
          }
        } else {
          stmt.bindNull(16);
          stmt.bindNull(17);
        }
      }
    };
    this.__insertionAdapterOfTouchTypeDataLocal_1 = new EntityInsertionAdapter<TouchTypeDataLocal>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR REPLACE INTO `touch_type_data` (`id`,`timeStamp`,`touchToolType`,`deviceId`,`pressure`,`radiusMajor`,`radiusMinor`,`orientation`,`gesture`,`offset2D_xOffset`,`offset2D_yOffset`,`position2D_xPosition`,`position2D_yPosition`,`pressureRange_lowerBound`,`pressureRange_upperBound`,`targetElement_targetId`,`targetElement_targetType`) VALUES (nullif(?, 0),?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, TouchTypeDataLocal value) {
        stmt.bindLong(1, value.getId());
        stmt.bindLong(2, value.getTimeStamp());
        if (value.getTouchToolType() == null) {
          stmt.bindNull(3);
        } else {
          stmt.bindString(3, __TouchToolType_enumToString(value.getTouchToolType()));
        }
        stmt.bindLong(4, value.getDeviceId());
        stmt.bindDouble(5, value.getPressure());
        stmt.bindDouble(6, value.getRadiusMajor());
        stmt.bindDouble(7, value.getRadiusMinor());
        stmt.bindDouble(8, value.getOrientation());
        if (value.getGesture() == null) {
          stmt.bindNull(9);
        } else {
          stmt.bindString(9, __Gesture_enumToString(value.getGesture()));
        }
        final Offset2D _tmpOffset2D = value.getOffset2D();
        if (_tmpOffset2D != null) {
          stmt.bindDouble(10, _tmpOffset2D.getXOffset());
          stmt.bindDouble(11, _tmpOffset2D.getYOffset());
        } else {
          stmt.bindNull(10);
          stmt.bindNull(11);
        }
        final Position2D _tmpPosition2D = value.getPosition2D();
        if (_tmpPosition2D != null) {
          stmt.bindDouble(12, _tmpPosition2D.getXPosition());
          stmt.bindDouble(13, _tmpPosition2D.getYPosition());
        } else {
          stmt.bindNull(12);
          stmt.bindNull(13);
        }
        final ClosedRange _tmpPressureRange = value.getPressureRange();
        if (_tmpPressureRange != null) {
          stmt.bindDouble(14, _tmpPressureRange.getLowerBound());
          stmt.bindDouble(15, _tmpPressureRange.getUpperBound());
        } else {
          stmt.bindNull(14);
          stmt.bindNull(15);
        }
        final TargetElement _tmpTargetElement = value.getTargetElement();
        if (_tmpTargetElement != null) {
          if (_tmpTargetElement.getTargetId() == null) {
            stmt.bindNull(16);
          } else {
            stmt.bindString(16, _tmpTargetElement.getTargetId());
          }
          if (_tmpTargetElement.getTargetType() == null) {
            stmt.bindNull(17);
          } else {
            stmt.bindString(17, _tmpTargetElement.getTargetType());
          }
        } else {
          stmt.bindNull(16);
          stmt.bindNull(17);
        }
      }
    };
    this.__insertionAdapterOfKeyPressEventLocal = new EntityInsertionAdapter<KeyPressEventLocal>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR ABORT INTO `key_press_data_table` (`id`,`timeStamp`,`keyPressType`,`maskedKey`,`targetElement_targetId`,`targetElement_targetType`) VALUES (nullif(?, 0),?,?,?,?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, KeyPressEventLocal value) {
        stmt.bindLong(1, value.getId());
        stmt.bindLong(2, value.getTimeStamp());
        if (value.getKeyPressType() == null) {
          stmt.bindNull(3);
        } else {
          stmt.bindString(3, __KeyPressType_enumToString(value.getKeyPressType()));
        }
        stmt.bindLong(4, value.getMaskedKey());
        final TargetElement _tmpTargetElement = value.getTargetElement();
        if (_tmpTargetElement != null) {
          if (_tmpTargetElement.getTargetId() == null) {
            stmt.bindNull(5);
          } else {
            stmt.bindString(5, _tmpTargetElement.getTargetId());
          }
          if (_tmpTargetElement.getTargetType() == null) {
            stmt.bindNull(6);
          } else {
            stmt.bindString(6, _tmpTargetElement.getTargetType());
          }
        } else {
          stmt.bindNull(5);
          stmt.bindNull(6);
        }
      }
    };
    this.__insertionAdapterOfKeyPressEventLocal_1 = new EntityInsertionAdapter<KeyPressEventLocal>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR REPLACE INTO `key_press_data_table` (`id`,`timeStamp`,`keyPressType`,`maskedKey`,`targetElement_targetId`,`targetElement_targetType`) VALUES (nullif(?, 0),?,?,?,?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, KeyPressEventLocal value) {
        stmt.bindLong(1, value.getId());
        stmt.bindLong(2, value.getTimeStamp());
        if (value.getKeyPressType() == null) {
          stmt.bindNull(3);
        } else {
          stmt.bindString(3, __KeyPressType_enumToString(value.getKeyPressType()));
        }
        stmt.bindLong(4, value.getMaskedKey());
        final TargetElement _tmpTargetElement = value.getTargetElement();
        if (_tmpTargetElement != null) {
          if (_tmpTargetElement.getTargetId() == null) {
            stmt.bindNull(5);
          } else {
            stmt.bindString(5, _tmpTargetElement.getTargetId());
          }
          if (_tmpTargetElement.getTargetType() == null) {
            stmt.bindNull(6);
          } else {
            stmt.bindString(6, _tmpTargetElement.getTargetType());
          }
        } else {
          stmt.bindNull(5);
          stmt.bindNull(6);
        }
      }
    };
    this.__insertionAdapterOfInputChangeEventLocal = new EntityInsertionAdapter<InputChangeEventLocal>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR ABORT INTO `input_change_data_table` (`id`,`timeStamp`,`focus`,`maskedText`,`inputChangeAction`,`targetElement_targetId`,`targetElement_targetType`) VALUES (nullif(?, 0),?,?,?,?,?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, InputChangeEventLocal value) {
        stmt.bindLong(1, value.getId());
        stmt.bindLong(2, value.getTimeStamp());
        final int _tmp = value.getFocus() ? 1 : 0;
        stmt.bindLong(3, _tmp);
        if (value.getMaskedText() == null) {
          stmt.bindNull(4);
        } else {
          stmt.bindString(4, value.getMaskedText());
        }
        if (value.getInputChangeAction() == null) {
          stmt.bindNull(5);
        } else {
          stmt.bindString(5, __InputChangeAction_enumToString(value.getInputChangeAction()));
        }
        final TargetElement _tmpTargetElement = value.getTargetElement();
        if (_tmpTargetElement != null) {
          if (_tmpTargetElement.getTargetId() == null) {
            stmt.bindNull(6);
          } else {
            stmt.bindString(6, _tmpTargetElement.getTargetId());
          }
          if (_tmpTargetElement.getTargetType() == null) {
            stmt.bindNull(7);
          } else {
            stmt.bindString(7, _tmpTargetElement.getTargetType());
          }
        } else {
          stmt.bindNull(6);
          stmt.bindNull(7);
        }
      }
    };
    this.__insertionAdapterOfInputChangeEventLocal_1 = new EntityInsertionAdapter<InputChangeEventLocal>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR REPLACE INTO `input_change_data_table` (`id`,`timeStamp`,`focus`,`maskedText`,`inputChangeAction`,`targetElement_targetId`,`targetElement_targetType`) VALUES (nullif(?, 0),?,?,?,?,?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, InputChangeEventLocal value) {
        stmt.bindLong(1, value.getId());
        stmt.bindLong(2, value.getTimeStamp());
        final int _tmp = value.getFocus() ? 1 : 0;
        stmt.bindLong(3, _tmp);
        if (value.getMaskedText() == null) {
          stmt.bindNull(4);
        } else {
          stmt.bindString(4, value.getMaskedText());
        }
        if (value.getInputChangeAction() == null) {
          stmt.bindNull(5);
        } else {
          stmt.bindString(5, __InputChangeAction_enumToString(value.getInputChangeAction()));
        }
        final TargetElement _tmpTargetElement = value.getTargetElement();
        if (_tmpTargetElement != null) {
          if (_tmpTargetElement.getTargetId() == null) {
            stmt.bindNull(6);
          } else {
            stmt.bindString(6, _tmpTargetElement.getTargetId());
          }
          if (_tmpTargetElement.getTargetType() == null) {
            stmt.bindNull(7);
          } else {
            stmt.bindString(7, _tmpTargetElement.getTargetType());
          }
        } else {
          stmt.bindNull(6);
          stmt.bindNull(7);
        }
      }
    };
    this.__insertionAdapterOfFocusChangeDataLocal = new EntityInsertionAdapter<FocusChangeDataLocal>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR ABORT INTO `focus_change_data_table` (`id`,`timeStamp`,`focusChangeType`,`targetElement_targetId`,`targetElement_targetType`) VALUES (nullif(?, 0),?,?,?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, FocusChangeDataLocal value) {
        stmt.bindLong(1, value.getId());
        stmt.bindLong(2, value.getTimeStamp());
        if (value.getFocusChangeType() == null) {
          stmt.bindNull(3);
        } else {
          stmt.bindString(3, __FocusChangeType_enumToString(value.getFocusChangeType()));
        }
        final TargetElement _tmpTargetElement = value.getTargetElement();
        if (_tmpTargetElement != null) {
          if (_tmpTargetElement.getTargetId() == null) {
            stmt.bindNull(4);
          } else {
            stmt.bindString(4, _tmpTargetElement.getTargetId());
          }
          if (_tmpTargetElement.getTargetType() == null) {
            stmt.bindNull(5);
          } else {
            stmt.bindString(5, _tmpTargetElement.getTargetType());
          }
        } else {
          stmt.bindNull(4);
          stmt.bindNull(5);
        }
      }
    };
    this.__insertionAdapterOfFocusChangeDataLocal_1 = new EntityInsertionAdapter<FocusChangeDataLocal>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR REPLACE INTO `focus_change_data_table` (`id`,`timeStamp`,`focusChangeType`,`targetElement_targetId`,`targetElement_targetType`) VALUES (nullif(?, 0),?,?,?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, FocusChangeDataLocal value) {
        stmt.bindLong(1, value.getId());
        stmt.bindLong(2, value.getTimeStamp());
        if (value.getFocusChangeType() == null) {
          stmt.bindNull(3);
        } else {
          stmt.bindString(3, __FocusChangeType_enumToString(value.getFocusChangeType()));
        }
        final TargetElement _tmpTargetElement = value.getTargetElement();
        if (_tmpTargetElement != null) {
          if (_tmpTargetElement.getTargetId() == null) {
            stmt.bindNull(4);
          } else {
            stmt.bindString(4, _tmpTargetElement.getTargetId());
          }
          if (_tmpTargetElement.getTargetType() == null) {
            stmt.bindNull(5);
          } else {
            stmt.bindString(5, _tmpTargetElement.getTargetType());
          }
        } else {
          stmt.bindNull(4);
          stmt.bindNull(5);
        }
      }
    };
    this.__insertionAdapterOfViewPortScrollDataLocal = new EntityInsertionAdapter<ViewPortScrollDataLocal>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR ABORT INTO `view_port_scroll_data_table` (`id`,`timeStamp`,`deltaX`,`deltaY`,`targetElement_targetId`,`targetElement_targetType`) VALUES (nullif(?, 0),?,?,?,?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, ViewPortScrollDataLocal value) {
        stmt.bindLong(1, value.getId());
        stmt.bindLong(2, value.getTimeStamp());
        stmt.bindLong(3, value.getDeltaX());
        stmt.bindLong(4, value.getDeltaY());
        final TargetElement _tmpTargetElement = value.getTargetElement();
        if (_tmpTargetElement != null) {
          if (_tmpTargetElement.getTargetId() == null) {
            stmt.bindNull(5);
          } else {
            stmt.bindString(5, _tmpTargetElement.getTargetId());
          }
          if (_tmpTargetElement.getTargetType() == null) {
            stmt.bindNull(6);
          } else {
            stmt.bindString(6, _tmpTargetElement.getTargetType());
          }
        } else {
          stmt.bindNull(5);
          stmt.bindNull(6);
        }
      }
    };
    this.__insertionAdapterOfViewPortScrollDataLocal_1 = new EntityInsertionAdapter<ViewPortScrollDataLocal>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR REPLACE INTO `view_port_scroll_data_table` (`id`,`timeStamp`,`deltaX`,`deltaY`,`targetElement_targetId`,`targetElement_targetType`) VALUES (nullif(?, 0),?,?,?,?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, ViewPortScrollDataLocal value) {
        stmt.bindLong(1, value.getId());
        stmt.bindLong(2, value.getTimeStamp());
        stmt.bindLong(3, value.getDeltaX());
        stmt.bindLong(4, value.getDeltaY());
        final TargetElement _tmpTargetElement = value.getTargetElement();
        if (_tmpTargetElement != null) {
          if (_tmpTargetElement.getTargetId() == null) {
            stmt.bindNull(5);
          } else {
            stmt.bindString(5, _tmpTargetElement.getTargetId());
          }
          if (_tmpTargetElement.getTargetType() == null) {
            stmt.bindNull(6);
          } else {
            stmt.bindString(6, _tmpTargetElement.getTargetType());
          }
        } else {
          stmt.bindNull(5);
          stmt.bindNull(6);
        }
      }
    };
    this.__insertionAdapterOfFrameRateEventLocal = new EntityInsertionAdapter<FrameRateEventLocal>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR ABORT INTO `frame_rate_event_table` (`id`,`timeStamp`,`frameRate`) VALUES (nullif(?, 0),?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, FrameRateEventLocal value) {
        stmt.bindLong(1, value.getId());
        stmt.bindLong(2, value.getTimeStamp());
        stmt.bindDouble(3, value.getFrameRate());
      }
    };
    this.__insertionAdapterOfFrameRateEventLocal_1 = new EntityInsertionAdapter<FrameRateEventLocal>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR REPLACE INTO `frame_rate_event_table` (`id`,`timeStamp`,`frameRate`) VALUES (nullif(?, 0),?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, FrameRateEventLocal value) {
        stmt.bindLong(1, value.getId());
        stmt.bindLong(2, value.getTimeStamp());
        stmt.bindDouble(3, value.getFrameRate());
      }
    };
    this.__insertionAdapterOfAccelerometerDataLocal = new EntityInsertionAdapter<AccelerometerDataLocal>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR ABORT INTO `accelerometer_data` (`id`,`timeStamp`,`xAcc`,`yAcc`,`zAcc`) VALUES (nullif(?, 0),?,?,?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, AccelerometerDataLocal value) {
        stmt.bindLong(1, value.getId());
        stmt.bindLong(2, value.getTimeStamp());
        stmt.bindDouble(3, value.getXAcc());
        stmt.bindDouble(4, value.getYAcc());
        stmt.bindDouble(5, value.getZAcc());
      }
    };
    this.__insertionAdapterOfAccelerometerDataLocal_1 = new EntityInsertionAdapter<AccelerometerDataLocal>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR REPLACE INTO `accelerometer_data` (`id`,`timeStamp`,`xAcc`,`yAcc`,`zAcc`) VALUES (nullif(?, 0),?,?,?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, AccelerometerDataLocal value) {
        stmt.bindLong(1, value.getId());
        stmt.bindLong(2, value.getTimeStamp());
        stmt.bindDouble(3, value.getXAcc());
        stmt.bindDouble(4, value.getYAcc());
        stmt.bindDouble(5, value.getZAcc());
      }
    };
    this.__insertionAdapterOfGyroscopeDataLocal = new EntityInsertionAdapter<GyroscopeDataLocal>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR ABORT INTO `gyroscope_data` (`id`,`timeStamp`,`xRot`,`yRot`,`zRot`) VALUES (nullif(?, 0),?,?,?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, GyroscopeDataLocal value) {
        stmt.bindLong(1, value.getId());
        stmt.bindLong(2, value.getTimeStamp());
        stmt.bindDouble(3, value.getXRot());
        stmt.bindDouble(4, value.getYRot());
        stmt.bindDouble(5, value.getZRot());
      }
    };
    this.__insertionAdapterOfGyroscopeDataLocal_1 = new EntityInsertionAdapter<GyroscopeDataLocal>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR REPLACE INTO `gyroscope_data` (`id`,`timeStamp`,`xRot`,`yRot`,`zRot`) VALUES (nullif(?, 0),?,?,?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, GyroscopeDataLocal value) {
        stmt.bindLong(1, value.getId());
        stmt.bindLong(2, value.getTimeStamp());
        stmt.bindDouble(3, value.getXRot());
        stmt.bindDouble(4, value.getYRot());
        stmt.bindDouble(5, value.getZRot());
      }
    };
    this.__deletionAdapterOfAppLifecycleEventLocal = new EntityDeletionOrUpdateAdapter<AppLifecycleEventLocal>(__db) {
      @Override
      public String createQuery() {
        return "DELETE FROM `app_life_cycle_events` WHERE `id` = ?";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, AppLifecycleEventLocal value) {
        stmt.bindLong(1, value.getId());
      }
    };
    this.__deletionAdapterOfTouchTypeDataLocal = new EntityDeletionOrUpdateAdapter<TouchTypeDataLocal>(__db) {
      @Override
      public String createQuery() {
        return "DELETE FROM `touch_type_data` WHERE `id` = ?";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, TouchTypeDataLocal value) {
        stmt.bindLong(1, value.getId());
      }
    };
    this.__deletionAdapterOfKeyPressEventLocal = new EntityDeletionOrUpdateAdapter<KeyPressEventLocal>(__db) {
      @Override
      public String createQuery() {
        return "DELETE FROM `key_press_data_table` WHERE `id` = ?";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, KeyPressEventLocal value) {
        stmt.bindLong(1, value.getId());
      }
    };
    this.__deletionAdapterOfInputChangeEventLocal = new EntityDeletionOrUpdateAdapter<InputChangeEventLocal>(__db) {
      @Override
      public String createQuery() {
        return "DELETE FROM `input_change_data_table` WHERE `id` = ?";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, InputChangeEventLocal value) {
        stmt.bindLong(1, value.getId());
      }
    };
    this.__deletionAdapterOfFocusChangeDataLocal = new EntityDeletionOrUpdateAdapter<FocusChangeDataLocal>(__db) {
      @Override
      public String createQuery() {
        return "DELETE FROM `focus_change_data_table` WHERE `id` = ?";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, FocusChangeDataLocal value) {
        stmt.bindLong(1, value.getId());
      }
    };
    this.__deletionAdapterOfViewPortScrollDataLocal = new EntityDeletionOrUpdateAdapter<ViewPortScrollDataLocal>(__db) {
      @Override
      public String createQuery() {
        return "DELETE FROM `view_port_scroll_data_table` WHERE `id` = ?";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, ViewPortScrollDataLocal value) {
        stmt.bindLong(1, value.getId());
      }
    };
    this.__deletionAdapterOfFrameRateEventLocal = new EntityDeletionOrUpdateAdapter<FrameRateEventLocal>(__db) {
      @Override
      public String createQuery() {
        return "DELETE FROM `frame_rate_event_table` WHERE `id` = ?";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, FrameRateEventLocal value) {
        stmt.bindLong(1, value.getId());
      }
    };
    this.__deletionAdapterOfAccelerometerDataLocal = new EntityDeletionOrUpdateAdapter<AccelerometerDataLocal>(__db) {
      @Override
      public String createQuery() {
        return "DELETE FROM `accelerometer_data` WHERE `id` = ?";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, AccelerometerDataLocal value) {
        stmt.bindLong(1, value.getId());
      }
    };
    this.__deletionAdapterOfGyroscopeDataLocal = new EntityDeletionOrUpdateAdapter<GyroscopeDataLocal>(__db) {
      @Override
      public String createQuery() {
        return "DELETE FROM `gyroscope_data` WHERE `id` = ?";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, GyroscopeDataLocal value) {
        stmt.bindLong(1, value.getId());
      }
    };
    this.__preparedStmtOfDeleteAllAppLifecycleEvents = new SharedSQLiteStatement(__db) {
      @Override
      public String createQuery() {
        final String _query = "DELETE FROM app_life_cycle_events";
        return _query;
      }
    };
    this.__preparedStmtOfDeleteAllTouchTypeData = new SharedSQLiteStatement(__db) {
      @Override
      public String createQuery() {
        final String _query = "DELETE FROM touch_type_data";
        return _query;
      }
    };
    this.__preparedStmtOfDeleteAllKeyPressEvent = new SharedSQLiteStatement(__db) {
      @Override
      public String createQuery() {
        final String _query = "DELETE FROM key_press_data_table";
        return _query;
      }
    };
    this.__preparedStmtOfDeleteAllInputChangeEvent = new SharedSQLiteStatement(__db) {
      @Override
      public String createQuery() {
        final String _query = "DELETE FROM input_change_data_table";
        return _query;
      }
    };
    this.__preparedStmtOfDeleteAllFocusChangeData = new SharedSQLiteStatement(__db) {
      @Override
      public String createQuery() {
        final String _query = "DELETE FROM focus_change_data_table";
        return _query;
      }
    };
    this.__preparedStmtOfDeleteAllViewPortScrollData = new SharedSQLiteStatement(__db) {
      @Override
      public String createQuery() {
        final String _query = "DELETE FROM view_port_scroll_data_table";
        return _query;
      }
    };
    this.__preparedStmtOfDeleteAllFrameRateEvent = new SharedSQLiteStatement(__db) {
      @Override
      public String createQuery() {
        final String _query = "DELETE FROM frame_rate_event_table";
        return _query;
      }
    };
    this.__preparedStmtOfDeleteAllAccelerometerData = new SharedSQLiteStatement(__db) {
      @Override
      public String createQuery() {
        final String _query = "DELETE FROM accelerometer_data";
        return _query;
      }
    };
    this.__preparedStmtOfDeleteAllGyroscopeData = new SharedSQLiteStatement(__db) {
      @Override
      public String createQuery() {
        final String _query = "DELETE FROM gyroscope_data";
        return _query;
      }
    };
  }

  @Override
  public Object insertAllAppLifecycleEvents(
      final List<AppLifecycleEventLocal> appLifecycleEventLocals,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __insertionAdapterOfAppLifecycleEventLocal.insert(appLifecycleEventLocals);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object insertAppLifecycleEvent(final AppLifecycleEventLocal appLifecycleEventLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __insertionAdapterOfAppLifecycleEventLocal_1.insert(appLifecycleEventLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object insertAllTouchTypeData(final List<TouchTypeDataLocal> touchTypeDataLocalList,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __insertionAdapterOfTouchTypeDataLocal.insert(touchTypeDataLocalList);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object insertTouchTypeData(final TouchTypeDataLocal touchTypeDataLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __insertionAdapterOfTouchTypeDataLocal_1.insert(touchTypeDataLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object insertAllKeyPressEvent(final List<KeyPressEventLocal> keyPressEventLocalList,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __insertionAdapterOfKeyPressEventLocal.insert(keyPressEventLocalList);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object insertKeyPressEvent(final KeyPressEventLocal keyPressEventLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __insertionAdapterOfKeyPressEventLocal_1.insert(keyPressEventLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object insertAllInputChangeEvent(
      final List<InputChangeEventLocal> inputChangeEventLocalList,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __insertionAdapterOfInputChangeEventLocal.insert(inputChangeEventLocalList);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object insertInputChangeEvent(final InputChangeEventLocal inputChangeEventLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __insertionAdapterOfInputChangeEventLocal_1.insert(inputChangeEventLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object insertAllFocusChangeData(final List<FocusChangeDataLocal> focusChangeDataLocalList,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __insertionAdapterOfFocusChangeDataLocal.insert(focusChangeDataLocalList);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object insertFocusChangeData(final FocusChangeDataLocal focusChangeDataLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __insertionAdapterOfFocusChangeDataLocal_1.insert(focusChangeDataLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object insertAllViewPortScrollData(
      final List<ViewPortScrollDataLocal> viewPortScrollDataLocalList,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __insertionAdapterOfViewPortScrollDataLocal.insert(viewPortScrollDataLocalList);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object insertViewPortScrollData(final ViewPortScrollDataLocal viewPortScrollDataLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __insertionAdapterOfViewPortScrollDataLocal_1.insert(viewPortScrollDataLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object insertAllFrameRateEvent(final List<FrameRateEventLocal> frameRateEventLocalList,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __insertionAdapterOfFrameRateEventLocal.insert(frameRateEventLocalList);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object insertFrameRateEvent(final FrameRateEventLocal frameRateEventLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __insertionAdapterOfFrameRateEventLocal_1.insert(frameRateEventLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object insertAllAccelerometerData(
      final List<AccelerometerDataLocal> accelerometerDataLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __insertionAdapterOfAccelerometerDataLocal.insert(accelerometerDataLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object insertAccelerometerData(final AccelerometerDataLocal accelerometerData,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __insertionAdapterOfAccelerometerDataLocal_1.insert(accelerometerData);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object insertAllGyroscopeData(final List<GyroscopeDataLocal> gyroscopeDataLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __insertionAdapterOfGyroscopeDataLocal.insert(gyroscopeDataLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object insertGyroscopeData(final GyroscopeDataLocal gyroscopeDataLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __insertionAdapterOfGyroscopeDataLocal_1.insert(gyroscopeDataLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteAppLifecycleEvent(final AppLifecycleEventLocal appLifecycleEventLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __deletionAdapterOfAppLifecycleEventLocal.handle(appLifecycleEventLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteAppLifecycleEventList(
      final List<AppLifecycleEventLocal> appLifecycleEventLocals,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __deletionAdapterOfAppLifecycleEventLocal.handleMultiple(appLifecycleEventLocals);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteTouchTypeData(final TouchTypeDataLocal touchTypeDataLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __deletionAdapterOfTouchTypeDataLocal.handle(touchTypeDataLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteTouchTypeDataList(final List<TouchTypeDataLocal> touchTypeDatumLocals,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __deletionAdapterOfTouchTypeDataLocal.handleMultiple(touchTypeDatumLocals);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteKeyPressEvent(final KeyPressEventLocal keyPressEventLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __deletionAdapterOfKeyPressEventLocal.handle(keyPressEventLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteKeyPressEventList(final List<KeyPressEventLocal> keyPressEventLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __deletionAdapterOfKeyPressEventLocal.handleMultiple(keyPressEventLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteInputChangeEvent(final InputChangeEventLocal inputChangeEventLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __deletionAdapterOfInputChangeEventLocal.handle(inputChangeEventLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteInputChangeEventList(final List<InputChangeEventLocal> inputChangeEventLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __deletionAdapterOfInputChangeEventLocal.handleMultiple(inputChangeEventLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteFocusChangeData(final FocusChangeDataLocal focusChangeDataLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __deletionAdapterOfFocusChangeDataLocal.handle(focusChangeDataLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteFocusChangeDataList(final List<FocusChangeDataLocal> focusChangeDatumLocals,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __deletionAdapterOfFocusChangeDataLocal.handleMultiple(focusChangeDatumLocals);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteViewPortScrollData(final ViewPortScrollDataLocal viewPortScrollDataLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __deletionAdapterOfViewPortScrollDataLocal.handle(viewPortScrollDataLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteViewPortScrollDataList(
      final List<ViewPortScrollDataLocal> viewPortScrollDatumLocals,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __deletionAdapterOfViewPortScrollDataLocal.handleMultiple(viewPortScrollDatumLocals);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteFrameRateEvent(final FrameRateEventLocal frameRateEventLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __deletionAdapterOfFrameRateEventLocal.handle(frameRateEventLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteFrameRateEventList(final List<FrameRateEventLocal> frameRateEventLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __deletionAdapterOfFrameRateEventLocal.handleMultiple(frameRateEventLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteAccelerometerData(final AccelerometerDataLocal accelerometerDataLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __deletionAdapterOfAccelerometerDataLocal.handle(accelerometerDataLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteAccelerometerDataList(
      final List<AccelerometerDataLocal> accelerometerDataLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __deletionAdapterOfAccelerometerDataLocal.handleMultiple(accelerometerDataLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteGyroscopeData(final GyroscopeDataLocal gyroscopeDataLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __deletionAdapterOfGyroscopeDataLocal.handle(gyroscopeDataLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteGyroscopeDataList(final List<GyroscopeDataLocal> gyroscopeDataLocal,
      final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        __db.beginTransaction();
        try {
          __deletionAdapterOfGyroscopeDataLocal.handleMultiple(gyroscopeDataLocal);
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteAllAppLifecycleEvents(final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        final SupportSQLiteStatement _stmt = __preparedStmtOfDeleteAllAppLifecycleEvents.acquire();
        __db.beginTransaction();
        try {
          _stmt.executeUpdateDelete();
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
          __preparedStmtOfDeleteAllAppLifecycleEvents.release(_stmt);
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteAllTouchTypeData(final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        final SupportSQLiteStatement _stmt = __preparedStmtOfDeleteAllTouchTypeData.acquire();
        __db.beginTransaction();
        try {
          _stmt.executeUpdateDelete();
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
          __preparedStmtOfDeleteAllTouchTypeData.release(_stmt);
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteAllKeyPressEvent(final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        final SupportSQLiteStatement _stmt = __preparedStmtOfDeleteAllKeyPressEvent.acquire();
        __db.beginTransaction();
        try {
          _stmt.executeUpdateDelete();
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
          __preparedStmtOfDeleteAllKeyPressEvent.release(_stmt);
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteAllInputChangeEvent(final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        final SupportSQLiteStatement _stmt = __preparedStmtOfDeleteAllInputChangeEvent.acquire();
        __db.beginTransaction();
        try {
          _stmt.executeUpdateDelete();
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
          __preparedStmtOfDeleteAllInputChangeEvent.release(_stmt);
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteAllFocusChangeData(final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        final SupportSQLiteStatement _stmt = __preparedStmtOfDeleteAllFocusChangeData.acquire();
        __db.beginTransaction();
        try {
          _stmt.executeUpdateDelete();
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
          __preparedStmtOfDeleteAllFocusChangeData.release(_stmt);
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteAllViewPortScrollData(final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        final SupportSQLiteStatement _stmt = __preparedStmtOfDeleteAllViewPortScrollData.acquire();
        __db.beginTransaction();
        try {
          _stmt.executeUpdateDelete();
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
          __preparedStmtOfDeleteAllViewPortScrollData.release(_stmt);
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteAllFrameRateEvent(final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        final SupportSQLiteStatement _stmt = __preparedStmtOfDeleteAllFrameRateEvent.acquire();
        __db.beginTransaction();
        try {
          _stmt.executeUpdateDelete();
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
          __preparedStmtOfDeleteAllFrameRateEvent.release(_stmt);
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteAllAccelerometerData(final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        final SupportSQLiteStatement _stmt = __preparedStmtOfDeleteAllAccelerometerData.acquire();
        __db.beginTransaction();
        try {
          _stmt.executeUpdateDelete();
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
          __preparedStmtOfDeleteAllAccelerometerData.release(_stmt);
        }
      }
    }, continuation);
  }

  @Override
  public Object deleteAllGyroscopeData(final Continuation<? super Unit> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Unit>() {
      @Override
      public Unit call() throws Exception {
        final SupportSQLiteStatement _stmt = __preparedStmtOfDeleteAllGyroscopeData.acquire();
        __db.beginTransaction();
        try {
          _stmt.executeUpdateDelete();
          __db.setTransactionSuccessful();
          return Unit.INSTANCE;
        } finally {
          __db.endTransaction();
          __preparedStmtOfDeleteAllGyroscopeData.release(_stmt);
        }
      }
    }, continuation);
  }

  @Override
  public Flow<List<AppLifecycleEventLocal>> getAllAppLifecycleEventsFlow() {
    final String _sql = "SELECT * FROM app_life_cycle_events";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    return CoroutinesRoom.createFlow(__db, false, new String[]{"app_life_cycle_events"}, new Callable<List<AppLifecycleEventLocal>>() {
      @Override
      public List<AppLifecycleEventLocal> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfId = CursorUtil.getColumnIndexOrThrow(_cursor, "id");
          final int _cursorIndexOfTimeStamp = CursorUtil.getColumnIndexOrThrow(_cursor, "timeStamp");
          final int _cursorIndexOfAppLifecycleStatus = CursorUtil.getColumnIndexOrThrow(_cursor, "appLifecycleStatus");
          final List<AppLifecycleEventLocal> _result = new ArrayList<AppLifecycleEventLocal>(_cursor.getCount());
          while(_cursor.moveToNext()) {
            final AppLifecycleEventLocal _item;
            final int _tmpId;
            _tmpId = _cursor.getInt(_cursorIndexOfId);
            final long _tmpTimeStamp;
            _tmpTimeStamp = _cursor.getLong(_cursorIndexOfTimeStamp);
            final AppLifecycleStatus _tmpAppLifecycleStatus;
            _tmpAppLifecycleStatus = __AppLifecycleStatus_stringToEnum(_cursor.getString(_cursorIndexOfAppLifecycleStatus));
            _item = new AppLifecycleEventLocal(_tmpId,_tmpTimeStamp,_tmpAppLifecycleStatus);
            _result.add(_item);
          }
          return _result;
        } finally {
          _cursor.close();
        }
      }

      @Override
      protected void finalize() {
        _statement.release();
      }
    });
  }

  @Override
  public Flow<List<TouchTypeDataLocal>> getAllTouchTypeDataFlow() {
    final String _sql = "SELECT * FROM touch_type_data";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    return CoroutinesRoom.createFlow(__db, false, new String[]{"touch_type_data"}, new Callable<List<TouchTypeDataLocal>>() {
      @Override
      public List<TouchTypeDataLocal> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfId = CursorUtil.getColumnIndexOrThrow(_cursor, "id");
          final int _cursorIndexOfTimeStamp = CursorUtil.getColumnIndexOrThrow(_cursor, "timeStamp");
          final int _cursorIndexOfTouchToolType = CursorUtil.getColumnIndexOrThrow(_cursor, "touchToolType");
          final int _cursorIndexOfDeviceId = CursorUtil.getColumnIndexOrThrow(_cursor, "deviceId");
          final int _cursorIndexOfPressure = CursorUtil.getColumnIndexOrThrow(_cursor, "pressure");
          final int _cursorIndexOfRadiusMajor = CursorUtil.getColumnIndexOrThrow(_cursor, "radiusMajor");
          final int _cursorIndexOfRadiusMinor = CursorUtil.getColumnIndexOrThrow(_cursor, "radiusMinor");
          final int _cursorIndexOfOrientation = CursorUtil.getColumnIndexOrThrow(_cursor, "orientation");
          final int _cursorIndexOfGesture = CursorUtil.getColumnIndexOrThrow(_cursor, "gesture");
          final int _cursorIndexOfXOffset = CursorUtil.getColumnIndexOrThrow(_cursor, "offset2D_xOffset");
          final int _cursorIndexOfYOffset = CursorUtil.getColumnIndexOrThrow(_cursor, "offset2D_yOffset");
          final int _cursorIndexOfXPosition = CursorUtil.getColumnIndexOrThrow(_cursor, "position2D_xPosition");
          final int _cursorIndexOfYPosition = CursorUtil.getColumnIndexOrThrow(_cursor, "position2D_yPosition");
          final int _cursorIndexOfLowerBound = CursorUtil.getColumnIndexOrThrow(_cursor, "pressureRange_lowerBound");
          final int _cursorIndexOfUpperBound = CursorUtil.getColumnIndexOrThrow(_cursor, "pressureRange_upperBound");
          final int _cursorIndexOfTargetId = CursorUtil.getColumnIndexOrThrow(_cursor, "targetElement_targetId");
          final int _cursorIndexOfTargetType = CursorUtil.getColumnIndexOrThrow(_cursor, "targetElement_targetType");
          final List<TouchTypeDataLocal> _result = new ArrayList<TouchTypeDataLocal>(_cursor.getCount());
          while(_cursor.moveToNext()) {
            final TouchTypeDataLocal _item;
            final int _tmpId;
            _tmpId = _cursor.getInt(_cursorIndexOfId);
            final long _tmpTimeStamp;
            _tmpTimeStamp = _cursor.getLong(_cursorIndexOfTimeStamp);
            final TouchToolType _tmpTouchToolType;
            _tmpTouchToolType = __TouchToolType_stringToEnum(_cursor.getString(_cursorIndexOfTouchToolType));
            final long _tmpDeviceId;
            _tmpDeviceId = _cursor.getLong(_cursorIndexOfDeviceId);
            final double _tmpPressure;
            _tmpPressure = _cursor.getDouble(_cursorIndexOfPressure);
            final double _tmpRadiusMajor;
            _tmpRadiusMajor = _cursor.getDouble(_cursorIndexOfRadiusMajor);
            final double _tmpRadiusMinor;
            _tmpRadiusMinor = _cursor.getDouble(_cursorIndexOfRadiusMinor);
            final double _tmpOrientation;
            _tmpOrientation = _cursor.getDouble(_cursorIndexOfOrientation);
            final Gesture _tmpGesture;
            _tmpGesture = __Gesture_stringToEnum(_cursor.getString(_cursorIndexOfGesture));
            final Offset2D _tmpOffset2D;
            final double _tmpXOffset;
            _tmpXOffset = _cursor.getDouble(_cursorIndexOfXOffset);
            final double _tmpYOffset;
            _tmpYOffset = _cursor.getDouble(_cursorIndexOfYOffset);
            _tmpOffset2D = new Offset2D(_tmpXOffset,_tmpYOffset);
            final Position2D _tmpPosition2D;
            final double _tmpXPosition;
            _tmpXPosition = _cursor.getDouble(_cursorIndexOfXPosition);
            final double _tmpYPosition;
            _tmpYPosition = _cursor.getDouble(_cursorIndexOfYPosition);
            _tmpPosition2D = new Position2D(_tmpXPosition,_tmpYPosition);
            final ClosedRange _tmpPressureRange;
            final double _tmpLowerBound;
            _tmpLowerBound = _cursor.getDouble(_cursorIndexOfLowerBound);
            final double _tmpUpperBound;
            _tmpUpperBound = _cursor.getDouble(_cursorIndexOfUpperBound);
            _tmpPressureRange = new ClosedRange(_tmpLowerBound,_tmpUpperBound);
            final TargetElement _tmpTargetElement;
            final String _tmpTargetId;
            if (_cursor.isNull(_cursorIndexOfTargetId)) {
              _tmpTargetId = null;
            } else {
              _tmpTargetId = _cursor.getString(_cursorIndexOfTargetId);
            }
            final String _tmpTargetType;
            if (_cursor.isNull(_cursorIndexOfTargetType)) {
              _tmpTargetType = null;
            } else {
              _tmpTargetType = _cursor.getString(_cursorIndexOfTargetType);
            }
            _tmpTargetElement = new TargetElement(_tmpTargetId,_tmpTargetType);
            _item = new TouchTypeDataLocal(_tmpId,_tmpTimeStamp,_tmpTouchToolType,_tmpOffset2D,_tmpDeviceId,_tmpPosition2D,_tmpPressure,_tmpPressureRange,_tmpRadiusMajor,_tmpRadiusMinor,_tmpOrientation,_tmpTargetElement,_tmpGesture);
            _result.add(_item);
          }
          return _result;
        } finally {
          _cursor.close();
        }
      }

      @Override
      protected void finalize() {
        _statement.release();
      }
    });
  }

  @Override
  public Flow<List<KeyPressEventLocal>> getAllKeyPressEventFlow() {
    final String _sql = "SELECT * FROM key_press_data_table";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    return CoroutinesRoom.createFlow(__db, false, new String[]{"key_press_data_table"}, new Callable<List<KeyPressEventLocal>>() {
      @Override
      public List<KeyPressEventLocal> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfId = CursorUtil.getColumnIndexOrThrow(_cursor, "id");
          final int _cursorIndexOfTimeStamp = CursorUtil.getColumnIndexOrThrow(_cursor, "timeStamp");
          final int _cursorIndexOfKeyPressType = CursorUtil.getColumnIndexOrThrow(_cursor, "keyPressType");
          final int _cursorIndexOfMaskedKey = CursorUtil.getColumnIndexOrThrow(_cursor, "maskedKey");
          final int _cursorIndexOfTargetId = CursorUtil.getColumnIndexOrThrow(_cursor, "targetElement_targetId");
          final int _cursorIndexOfTargetType = CursorUtil.getColumnIndexOrThrow(_cursor, "targetElement_targetType");
          final List<KeyPressEventLocal> _result = new ArrayList<KeyPressEventLocal>(_cursor.getCount());
          while(_cursor.moveToNext()) {
            final KeyPressEventLocal _item;
            final int _tmpId;
            _tmpId = _cursor.getInt(_cursorIndexOfId);
            final long _tmpTimeStamp;
            _tmpTimeStamp = _cursor.getLong(_cursorIndexOfTimeStamp);
            final KeyPressType _tmpKeyPressType;
            _tmpKeyPressType = __KeyPressType_stringToEnum(_cursor.getString(_cursorIndexOfKeyPressType));
            final int _tmpMaskedKey;
            _tmpMaskedKey = _cursor.getInt(_cursorIndexOfMaskedKey);
            final TargetElement _tmpTargetElement;
            final String _tmpTargetId;
            if (_cursor.isNull(_cursorIndexOfTargetId)) {
              _tmpTargetId = null;
            } else {
              _tmpTargetId = _cursor.getString(_cursorIndexOfTargetId);
            }
            final String _tmpTargetType;
            if (_cursor.isNull(_cursorIndexOfTargetType)) {
              _tmpTargetType = null;
            } else {
              _tmpTargetType = _cursor.getString(_cursorIndexOfTargetType);
            }
            _tmpTargetElement = new TargetElement(_tmpTargetId,_tmpTargetType);
            _item = new KeyPressEventLocal(_tmpId,_tmpTimeStamp,_tmpKeyPressType,_tmpMaskedKey,_tmpTargetElement);
            _result.add(_item);
          }
          return _result;
        } finally {
          _cursor.close();
        }
      }

      @Override
      protected void finalize() {
        _statement.release();
      }
    });
  }

  @Override
  public Flow<List<InputChangeEventLocal>> getAllInputChangeEventFlow() {
    final String _sql = "SELECT * FROM input_change_data_table";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    return CoroutinesRoom.createFlow(__db, false, new String[]{"input_change_data_table"}, new Callable<List<InputChangeEventLocal>>() {
      @Override
      public List<InputChangeEventLocal> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfId = CursorUtil.getColumnIndexOrThrow(_cursor, "id");
          final int _cursorIndexOfTimeStamp = CursorUtil.getColumnIndexOrThrow(_cursor, "timeStamp");
          final int _cursorIndexOfFocus = CursorUtil.getColumnIndexOrThrow(_cursor, "focus");
          final int _cursorIndexOfMaskedText = CursorUtil.getColumnIndexOrThrow(_cursor, "maskedText");
          final int _cursorIndexOfInputChangeAction = CursorUtil.getColumnIndexOrThrow(_cursor, "inputChangeAction");
          final int _cursorIndexOfTargetId = CursorUtil.getColumnIndexOrThrow(_cursor, "targetElement_targetId");
          final int _cursorIndexOfTargetType = CursorUtil.getColumnIndexOrThrow(_cursor, "targetElement_targetType");
          final List<InputChangeEventLocal> _result = new ArrayList<InputChangeEventLocal>(_cursor.getCount());
          while(_cursor.moveToNext()) {
            final InputChangeEventLocal _item;
            final int _tmpId;
            _tmpId = _cursor.getInt(_cursorIndexOfId);
            final long _tmpTimeStamp;
            _tmpTimeStamp = _cursor.getLong(_cursorIndexOfTimeStamp);
            final boolean _tmpFocus;
            final int _tmp;
            _tmp = _cursor.getInt(_cursorIndexOfFocus);
            _tmpFocus = _tmp != 0;
            final String _tmpMaskedText;
            if (_cursor.isNull(_cursorIndexOfMaskedText)) {
              _tmpMaskedText = null;
            } else {
              _tmpMaskedText = _cursor.getString(_cursorIndexOfMaskedText);
            }
            final InputChangeAction _tmpInputChangeAction;
            _tmpInputChangeAction = __InputChangeAction_stringToEnum(_cursor.getString(_cursorIndexOfInputChangeAction));
            final TargetElement _tmpTargetElement;
            final String _tmpTargetId;
            if (_cursor.isNull(_cursorIndexOfTargetId)) {
              _tmpTargetId = null;
            } else {
              _tmpTargetId = _cursor.getString(_cursorIndexOfTargetId);
            }
            final String _tmpTargetType;
            if (_cursor.isNull(_cursorIndexOfTargetType)) {
              _tmpTargetType = null;
            } else {
              _tmpTargetType = _cursor.getString(_cursorIndexOfTargetType);
            }
            _tmpTargetElement = new TargetElement(_tmpTargetId,_tmpTargetType);
            _item = new InputChangeEventLocal(_tmpId,_tmpTimeStamp,_tmpTargetElement,_tmpFocus,_tmpMaskedText,_tmpInputChangeAction);
            _result.add(_item);
          }
          return _result;
        } finally {
          _cursor.close();
        }
      }

      @Override
      protected void finalize() {
        _statement.release();
      }
    });
  }

  @Override
  public Flow<List<FocusChangeDataLocal>> getAllFocusChangeDataFlow() {
    final String _sql = "SELECT * FROM focus_change_data_table";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    return CoroutinesRoom.createFlow(__db, false, new String[]{"focus_change_data_table"}, new Callable<List<FocusChangeDataLocal>>() {
      @Override
      public List<FocusChangeDataLocal> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfId = CursorUtil.getColumnIndexOrThrow(_cursor, "id");
          final int _cursorIndexOfTimeStamp = CursorUtil.getColumnIndexOrThrow(_cursor, "timeStamp");
          final int _cursorIndexOfFocusChangeType = CursorUtil.getColumnIndexOrThrow(_cursor, "focusChangeType");
          final int _cursorIndexOfTargetId = CursorUtil.getColumnIndexOrThrow(_cursor, "targetElement_targetId");
          final int _cursorIndexOfTargetType = CursorUtil.getColumnIndexOrThrow(_cursor, "targetElement_targetType");
          final List<FocusChangeDataLocal> _result = new ArrayList<FocusChangeDataLocal>(_cursor.getCount());
          while(_cursor.moveToNext()) {
            final FocusChangeDataLocal _item;
            final int _tmpId;
            _tmpId = _cursor.getInt(_cursorIndexOfId);
            final long _tmpTimeStamp;
            _tmpTimeStamp = _cursor.getLong(_cursorIndexOfTimeStamp);
            final FocusChangeType _tmpFocusChangeType;
            _tmpFocusChangeType = __FocusChangeType_stringToEnum(_cursor.getString(_cursorIndexOfFocusChangeType));
            final TargetElement _tmpTargetElement;
            final String _tmpTargetId;
            if (_cursor.isNull(_cursorIndexOfTargetId)) {
              _tmpTargetId = null;
            } else {
              _tmpTargetId = _cursor.getString(_cursorIndexOfTargetId);
            }
            final String _tmpTargetType;
            if (_cursor.isNull(_cursorIndexOfTargetType)) {
              _tmpTargetType = null;
            } else {
              _tmpTargetType = _cursor.getString(_cursorIndexOfTargetType);
            }
            _tmpTargetElement = new TargetElement(_tmpTargetId,_tmpTargetType);
            _item = new FocusChangeDataLocal(_tmpId,_tmpTimeStamp,_tmpFocusChangeType,_tmpTargetElement);
            _result.add(_item);
          }
          return _result;
        } finally {
          _cursor.close();
        }
      }

      @Override
      protected void finalize() {
        _statement.release();
      }
    });
  }

  @Override
  public Flow<List<ViewPortScrollDataLocal>> getAllViewPortScrollDataFlow() {
    final String _sql = "SELECT * FROM view_port_scroll_data_table";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    return CoroutinesRoom.createFlow(__db, false, new String[]{"view_port_scroll_data_table"}, new Callable<List<ViewPortScrollDataLocal>>() {
      @Override
      public List<ViewPortScrollDataLocal> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfId = CursorUtil.getColumnIndexOrThrow(_cursor, "id");
          final int _cursorIndexOfTimeStamp = CursorUtil.getColumnIndexOrThrow(_cursor, "timeStamp");
          final int _cursorIndexOfDeltaX = CursorUtil.getColumnIndexOrThrow(_cursor, "deltaX");
          final int _cursorIndexOfDeltaY = CursorUtil.getColumnIndexOrThrow(_cursor, "deltaY");
          final int _cursorIndexOfTargetId = CursorUtil.getColumnIndexOrThrow(_cursor, "targetElement_targetId");
          final int _cursorIndexOfTargetType = CursorUtil.getColumnIndexOrThrow(_cursor, "targetElement_targetType");
          final List<ViewPortScrollDataLocal> _result = new ArrayList<ViewPortScrollDataLocal>(_cursor.getCount());
          while(_cursor.moveToNext()) {
            final ViewPortScrollDataLocal _item;
            final int _tmpId;
            _tmpId = _cursor.getInt(_cursorIndexOfId);
            final long _tmpTimeStamp;
            _tmpTimeStamp = _cursor.getLong(_cursorIndexOfTimeStamp);
            final long _tmpDeltaX;
            _tmpDeltaX = _cursor.getLong(_cursorIndexOfDeltaX);
            final long _tmpDeltaY;
            _tmpDeltaY = _cursor.getLong(_cursorIndexOfDeltaY);
            final TargetElement _tmpTargetElement;
            final String _tmpTargetId;
            if (_cursor.isNull(_cursorIndexOfTargetId)) {
              _tmpTargetId = null;
            } else {
              _tmpTargetId = _cursor.getString(_cursorIndexOfTargetId);
            }
            final String _tmpTargetType;
            if (_cursor.isNull(_cursorIndexOfTargetType)) {
              _tmpTargetType = null;
            } else {
              _tmpTargetType = _cursor.getString(_cursorIndexOfTargetType);
            }
            _tmpTargetElement = new TargetElement(_tmpTargetId,_tmpTargetType);
            _item = new ViewPortScrollDataLocal(_tmpId,_tmpTimeStamp,_tmpDeltaX,_tmpDeltaY,_tmpTargetElement);
            _result.add(_item);
          }
          return _result;
        } finally {
          _cursor.close();
        }
      }

      @Override
      protected void finalize() {
        _statement.release();
      }
    });
  }

  @Override
  public Flow<List<FrameRateEventLocal>> getAllFrameRateEventFlow() {
    final String _sql = "SELECT * FROM frame_rate_event_table";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    return CoroutinesRoom.createFlow(__db, false, new String[]{"frame_rate_event_table"}, new Callable<List<FrameRateEventLocal>>() {
      @Override
      public List<FrameRateEventLocal> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfId = CursorUtil.getColumnIndexOrThrow(_cursor, "id");
          final int _cursorIndexOfTimeStamp = CursorUtil.getColumnIndexOrThrow(_cursor, "timeStamp");
          final int _cursorIndexOfFrameRate = CursorUtil.getColumnIndexOrThrow(_cursor, "frameRate");
          final List<FrameRateEventLocal> _result = new ArrayList<FrameRateEventLocal>(_cursor.getCount());
          while(_cursor.moveToNext()) {
            final FrameRateEventLocal _item;
            final int _tmpId;
            _tmpId = _cursor.getInt(_cursorIndexOfId);
            final long _tmpTimeStamp;
            _tmpTimeStamp = _cursor.getLong(_cursorIndexOfTimeStamp);
            final float _tmpFrameRate;
            _tmpFrameRate = _cursor.getFloat(_cursorIndexOfFrameRate);
            _item = new FrameRateEventLocal(_tmpId,_tmpTimeStamp,_tmpFrameRate);
            _result.add(_item);
          }
          return _result;
        } finally {
          _cursor.close();
        }
      }

      @Override
      protected void finalize() {
        _statement.release();
      }
    });
  }

  @Override
  public Flow<List<AccelerometerDataLocal>> getAllAccelerometerDataFlow() {
    final String _sql = "SELECT * FROM accelerometer_data";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    return CoroutinesRoom.createFlow(__db, false, new String[]{"accelerometer_data"}, new Callable<List<AccelerometerDataLocal>>() {
      @Override
      public List<AccelerometerDataLocal> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfId = CursorUtil.getColumnIndexOrThrow(_cursor, "id");
          final int _cursorIndexOfTimeStamp = CursorUtil.getColumnIndexOrThrow(_cursor, "timeStamp");
          final int _cursorIndexOfXAcc = CursorUtil.getColumnIndexOrThrow(_cursor, "xAcc");
          final int _cursorIndexOfYAcc = CursorUtil.getColumnIndexOrThrow(_cursor, "yAcc");
          final int _cursorIndexOfZAcc = CursorUtil.getColumnIndexOrThrow(_cursor, "zAcc");
          final List<AccelerometerDataLocal> _result = new ArrayList<AccelerometerDataLocal>(_cursor.getCount());
          while(_cursor.moveToNext()) {
            final AccelerometerDataLocal _item;
            final int _tmpId;
            _tmpId = _cursor.getInt(_cursorIndexOfId);
            final long _tmpTimeStamp;
            _tmpTimeStamp = _cursor.getLong(_cursorIndexOfTimeStamp);
            final double _tmpXAcc;
            _tmpXAcc = _cursor.getDouble(_cursorIndexOfXAcc);
            final double _tmpYAcc;
            _tmpYAcc = _cursor.getDouble(_cursorIndexOfYAcc);
            final double _tmpZAcc;
            _tmpZAcc = _cursor.getDouble(_cursorIndexOfZAcc);
            _item = new AccelerometerDataLocal(_tmpId,_tmpTimeStamp,_tmpXAcc,_tmpYAcc,_tmpZAcc);
            _result.add(_item);
          }
          return _result;
        } finally {
          _cursor.close();
        }
      }

      @Override
      protected void finalize() {
        _statement.release();
      }
    });
  }

  @Override
  public Flow<List<GyroscopeDataLocal>> getAllGyroscopeDataFlow() {
    final String _sql = "SELECT * FROM gyroscope_data";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    return CoroutinesRoom.createFlow(__db, false, new String[]{"gyroscope_data"}, new Callable<List<GyroscopeDataLocal>>() {
      @Override
      public List<GyroscopeDataLocal> call() throws Exception {
        final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
        try {
          final int _cursorIndexOfId = CursorUtil.getColumnIndexOrThrow(_cursor, "id");
          final int _cursorIndexOfTimeStamp = CursorUtil.getColumnIndexOrThrow(_cursor, "timeStamp");
          final int _cursorIndexOfXRot = CursorUtil.getColumnIndexOrThrow(_cursor, "xRot");
          final int _cursorIndexOfYRot = CursorUtil.getColumnIndexOrThrow(_cursor, "yRot");
          final int _cursorIndexOfZRot = CursorUtil.getColumnIndexOrThrow(_cursor, "zRot");
          final List<GyroscopeDataLocal> _result = new ArrayList<GyroscopeDataLocal>(_cursor.getCount());
          while(_cursor.moveToNext()) {
            final GyroscopeDataLocal _item;
            final int _tmpId;
            _tmpId = _cursor.getInt(_cursorIndexOfId);
            final long _tmpTimeStamp;
            _tmpTimeStamp = _cursor.getLong(_cursorIndexOfTimeStamp);
            final double _tmpXRot;
            _tmpXRot = _cursor.getDouble(_cursorIndexOfXRot);
            final double _tmpYRot;
            _tmpYRot = _cursor.getDouble(_cursorIndexOfYRot);
            final double _tmpZRot;
            _tmpZRot = _cursor.getDouble(_cursorIndexOfZRot);
            _item = new GyroscopeDataLocal(_tmpId,_tmpTimeStamp,_tmpXRot,_tmpYRot,_tmpZRot);
            _result.add(_item);
          }
          return _result;
        } finally {
          _cursor.close();
        }
      }

      @Override
      protected void finalize() {
        _statement.release();
      }
    });
  }

  public static List<Class<?>> getRequiredConverters() {
    return Collections.emptyList();
  }

  private String __AppLifecycleStatus_enumToString(final AppLifecycleStatus _value) {
    if (_value == null) {
      return null;
    } switch (_value) {
      case UNKNOWN_APP_LIFE_CYCLE_STATUS: return "UNKNOWN_APP_LIFE_CYCLE_STATUS";
      case FOREGROUND: return "FOREGROUND";
      case BACKGROUND: return "BACKGROUND";
      case DESTROY: return "DESTROY";
      default: throw new IllegalArgumentException("Can't convert enum to string, unknown enum value: " + _value);
    }
  }

  private String __TouchToolType_enumToString(final TouchToolType _value) {
    if (_value == null) {
      return null;
    } switch (_value) {
      case STYLUS: return "STYLUS";
      case TOUCH: return "TOUCH";
      case UNKNOWN: return "UNKNOWN";
      case MOUSE: return "MOUSE";
      case ERASER: return "ERASER";
      default: throw new IllegalArgumentException("Can't convert enum to string, unknown enum value: " + _value);
    }
  }

  private String __Gesture_enumToString(final Gesture _value) {
    if (_value == null) {
      return null;
    } switch (_value) {
      case SCROLL: return "SCROLL";
      case SINGE_TAP: return "SINGE_TAP";
      case DOUBLE_TAP: return "DOUBLE_TAP";
      case FLING: return "FLING";
      case LONG_PRESS: return "LONG_PRESS";
      default: throw new IllegalArgumentException("Can't convert enum to string, unknown enum value: " + _value);
    }
  }

  private String __KeyPressType_enumToString(final KeyPressType _value) {
    if (_value == null) {
      return null;
    } switch (_value) {
      case KEY_UP: return "KEY_UP";
      case KEY_DOWN: return "KEY_DOWN";
      case UNKNOWN: return "UNKNOWN";
      default: throw new IllegalArgumentException("Can't convert enum to string, unknown enum value: " + _value);
    }
  }

  private String __InputChangeAction_enumToString(final InputChangeAction _value) {
    if (_value == null) {
      return null;
    } switch (_value) {
      case CUT: return "CUT";
      case COPY: return "COPY";
      case PASTE: return "PASTE";
      case AUTOFILL: return "AUTOFILL";
      case REPLACEMENT: return "REPLACEMENT";
      case UNKNOWN: return "UNKNOWN";
      default: throw new IllegalArgumentException("Can't convert enum to string, unknown enum value: " + _value);
    }
  }

  private String __FocusChangeType_enumToString(final FocusChangeType _value) {
    if (_value == null) {
      return null;
    } switch (_value) {
      case FOCUS_GAINED: return "FOCUS_GAINED";
      case FOCUS_LOST: return "FOCUS_LOST";
      case UNKNOWN: return "UNKNOWN";
      default: throw new IllegalArgumentException("Can't convert enum to string, unknown enum value: " + _value);
    }
  }

  private AppLifecycleStatus __AppLifecycleStatus_stringToEnum(final String _value) {
    if (_value == null) {
      return null;
    } switch (_value) {
      case "UNKNOWN_APP_LIFE_CYCLE_STATUS": return AppLifecycleStatus.UNKNOWN_APP_LIFE_CYCLE_STATUS;
      case "FOREGROUND": return AppLifecycleStatus.FOREGROUND;
      case "BACKGROUND": return AppLifecycleStatus.BACKGROUND;
      case "DESTROY": return AppLifecycleStatus.DESTROY;
      default: throw new IllegalArgumentException("Can't convert value to enum, unknown value: " + _value);
    }
  }

  private TouchToolType __TouchToolType_stringToEnum(final String _value) {
    if (_value == null) {
      return null;
    } switch (_value) {
      case "STYLUS": return TouchToolType.STYLUS;
      case "TOUCH": return TouchToolType.TOUCH;
      case "UNKNOWN": return TouchToolType.UNKNOWN;
      case "MOUSE": return TouchToolType.MOUSE;
      case "ERASER": return TouchToolType.ERASER;
      default: throw new IllegalArgumentException("Can't convert value to enum, unknown value: " + _value);
    }
  }

  private Gesture __Gesture_stringToEnum(final String _value) {
    if (_value == null) {
      return null;
    } switch (_value) {
      case "SCROLL": return Gesture.SCROLL;
      case "SINGE_TAP": return Gesture.SINGE_TAP;
      case "DOUBLE_TAP": return Gesture.DOUBLE_TAP;
      case "FLING": return Gesture.FLING;
      case "LONG_PRESS": return Gesture.LONG_PRESS;
      default: throw new IllegalArgumentException("Can't convert value to enum, unknown value: " + _value);
    }
  }

  private KeyPressType __KeyPressType_stringToEnum(final String _value) {
    if (_value == null) {
      return null;
    } switch (_value) {
      case "KEY_UP": return KeyPressType.KEY_UP;
      case "KEY_DOWN": return KeyPressType.KEY_DOWN;
      case "UNKNOWN": return KeyPressType.UNKNOWN;
      default: throw new IllegalArgumentException("Can't convert value to enum, unknown value: " + _value);
    }
  }

  private InputChangeAction __InputChangeAction_stringToEnum(final String _value) {
    if (_value == null) {
      return null;
    } switch (_value) {
      case "CUT": return InputChangeAction.CUT;
      case "COPY": return InputChangeAction.COPY;
      case "PASTE": return InputChangeAction.PASTE;
      case "AUTOFILL": return InputChangeAction.AUTOFILL;
      case "REPLACEMENT": return InputChangeAction.REPLACEMENT;
      case "UNKNOWN": return InputChangeAction.UNKNOWN;
      default: throw new IllegalArgumentException("Can't convert value to enum, unknown value: " + _value);
    }
  }

  private FocusChangeType __FocusChangeType_stringToEnum(final String _value) {
    if (_value == null) {
      return null;
    } switch (_value) {
      case "FOCUS_GAINED": return FocusChangeType.FOCUS_GAINED;
      case "FOCUS_LOST": return FocusChangeType.FOCUS_LOST;
      case "UNKNOWN": return FocusChangeType.UNKNOWN;
      default: throw new IllegalArgumentException("Can't convert value to enum, unknown value: " + _value);
    }
  }
}
