package com.bureau.behavioralbiometrics.applifecycleevents.models

import androidx.room.Entity
import androidx.room.PrimaryKey
import com.bureau.behavioralbiometrics.data.remote.protoModels.AppLifeCycleEvents
import com.bureau.behavioralbiometrics.data.remote.protoModels.appLifeCycleEvents

@Entity(tableName = "app_life_cycle_events")
data class AppLifecycleEventLocal(@PrimaryKey(autoGenerate = true) var id: Int = 0, val timeStamp: Long, val appLifecycleStatus: AppLifecycleStatus)

enum class AppLifecycleStatus {
    UNKNOWN_APP_LIFE_CYCLE_STATUS,
    FOREGROUND,
    BACKGROUND,
    DESTROY
}

fun AppLifecycleEventLocal.toAppLifeCyEvents(): AppLifeCycleEvents = appLifeCycleEvents {
    appLifeCycleStatus = appLifecycleStatus.name
    determinedAt = timeStamp
}
