package com.bureau.behavioralbiometrics.data

import com.bureau.behavioralbiometrics.applifecycleevents.models.AppLifecycleEventLocal
import com.bureau.behavioralbiometrics.focuschangedata.models.FocusChangeDataLocal
import com.bureau.behavioralbiometrics.frameratecollection.models.FrameRateEventLocal
import com.bureau.behavioralbiometrics.keypressTypedata.models.InputChangeEventLocal
import com.bureau.behavioralbiometrics.keypressTypedata.models.KeyPressEventLocal
import com.bureau.behavioralbiometrics.sensordata.models.AccelerometerDataLocal
import com.bureau.behavioralbiometrics.sensordata.models.GyroscopeDataLocal
import com.bureau.behavioralbiometrics.touchtypedata.models.TouchTypeDataLocal
import com.bureau.behavioralbiometrics.touchtypedata.models.ViewPortScrollDataLocal
import kotlinx.coroutines.flow.Flow

interface BBRepository {
    suspend fun insertAppLifecycleEvent(appLifecycleEventLocal: AppLifecycleEventLocal)

    fun getAllAppLifecycleEventsFlow(): Flow<List<AppLifecycleEventLocal>>

    suspend fun deleteAppLifecycleEventList(appLifecycleEventLocals: List<AppLifecycleEventLocal>)

    suspend fun deleteAllAppLifecycleEvents()

    suspend fun insertTouchTypeData(touchTypeDataLocal: TouchTypeDataLocal)

    fun getAllTouchTypeDataFlow(): Flow<List<TouchTypeDataLocal>>

    suspend fun deleteTouchTypeDataList(touchTypeDatumLocals: List<TouchTypeDataLocal>)

    suspend fun deleteAllTouchTypeData()

    suspend fun insertKeyPressEvent(keyPressEventLocal: KeyPressEventLocal)

    fun getAllKeyPressEventFlow(): Flow<List<KeyPressEventLocal>>

    suspend fun deleteKeyPressEventList(keyPressEventLocal: List<KeyPressEventLocal>)

    suspend fun deleteAllKeyPressEvents()

    suspend fun insertInputChangeEvent(inputChangeEventLocal: InputChangeEventLocal)

    fun getAllInputChangeEventFlow(): Flow<List<InputChangeEventLocal>>

    suspend fun deleteInputChangeEventList(inputChangeEventLocal: List<InputChangeEventLocal>)

    suspend fun deleteAllInputChangeEvents()

    suspend fun insertFocusChangeData(focusChangeDataLocal: FocusChangeDataLocal)

    fun getAllFocusChangeDataFlow(): Flow<List<FocusChangeDataLocal>>

    suspend fun deleteFocusChangeDataList(focusChangeDatumLocals: List<FocusChangeDataLocal>)

    suspend fun deleteAllFocusChangeData()

    suspend fun insertViewPortScrollData(focusChangeData: ViewPortScrollDataLocal)

    fun getAllViewPortScrollDataFlow(): Flow<List<ViewPortScrollDataLocal>>

    suspend fun deleteViewPortScrollDataList(viewPortScrollDatumLocals: List<ViewPortScrollDataLocal>)

    suspend fun deleteAllViewPortScrollData()

    suspend fun insertFrameRateEvent(frameRateEventLocal: FrameRateEventLocal)

    fun getAllFrameRateEventFlow(): Flow<List<FrameRateEventLocal>>

    suspend fun deleteFrameRateEventList(frameRateEventLocal: List<FrameRateEventLocal>)

    suspend fun deleteAllFrameRateEvents()

    suspend fun insertAccelerometerData(accelerometerDataLocal: AccelerometerDataLocal)

    fun getAllAccelerometerDataFlow(): Flow<List<AccelerometerDataLocal>>

    suspend fun deleteAccelerometerDataList(accelerometerDataLocal: List<AccelerometerDataLocal>)

    suspend fun deleteAllAccelerometerData()

    suspend fun insertGyroscopeData(gyroscopeDataLocal: GyroscopeDataLocal)

    fun getAllGyroscopeDataFlow(): Flow<List<GyroscopeDataLocal>>

    suspend fun deleteGyroscopeDataList(gyroscopeDataLocal: List<GyroscopeDataLocal>)

    suspend fun deleteAllGyroscopeData()

    suspend fun registerSubSession(sessionId: String, subSessionId: String, userId: String): Boolean
}
