package com.bureau.behavioralbiometrics.data.local

import androidx.room.Database
import androidx.room.RoomDatabase
import com.bureau.behavioralbiometrics.applifecycleevents.models.AppLifecycleEventLocal
import com.bureau.behavioralbiometrics.data.local.dao.BBDao
import com.bureau.behavioralbiometrics.focuschangedata.models.FocusChangeDataLocal
import com.bureau.behavioralbiometrics.frameratecollection.models.FrameRateEventLocal
import com.bureau.behavioralbiometrics.keypressTypedata.models.InputChangeEventLocal
import com.bureau.behavioralbiometrics.keypressTypedata.models.KeyPressEventLocal
import com.bureau.behavioralbiometrics.sensordata.models.AccelerometerDataLocal
import com.bureau.behavioralbiometrics.sensordata.models.GyroscopeDataLocal
import com.bureau.behavioralbiometrics.touchtypedata.models.TouchTypeDataLocal
import com.bureau.behavioralbiometrics.touchtypedata.models.ViewPortScrollDataLocal

@Database(
    entities = [
        AppLifecycleEventLocal::class,
        TouchTypeDataLocal::class,
        KeyPressEventLocal::class,
        InputChangeEventLocal::class,
        FocusChangeDataLocal::class,
        ViewPortScrollDataLocal::class,
        FrameRateEventLocal::class,
        AccelerometerDataLocal::class,
        GyroscopeDataLocal::class
    ],
    version = 1,
    exportSchema = false
)
abstract class BBDatabase : RoomDatabase() {
    abstract fun bbDao(): BBDao
}
