package com.bureau.behavioralbiometrics.data.local

import com.bureau.behavioralbiometrics.applifecycleevents.models.AppLifecycleEventLocal
import com.bureau.behavioralbiometrics.data.local.dao.BBDao
import com.bureau.behavioralbiometrics.di.BBScope
import com.bureau.behavioralbiometrics.focuschangedata.models.FocusChangeDataLocal
import com.bureau.behavioralbiometrics.frameratecollection.models.FrameRateEventLocal
import com.bureau.behavioralbiometrics.keypressTypedata.models.InputChangeEventLocal
import com.bureau.behavioralbiometrics.keypressTypedata.models.KeyPressEventLocal
import com.bureau.behavioralbiometrics.sensordata.models.AccelerometerDataLocal
import com.bureau.behavioralbiometrics.sensordata.models.GyroscopeDataLocal
import com.bureau.behavioralbiometrics.touchtypedata.models.TouchTypeDataLocal
import com.bureau.behavioralbiometrics.touchtypedata.models.ViewPortScrollDataLocal
import kotlinx.coroutines.flow.Flow
import javax.inject.Inject

@BBScope
class BBLocalDataSourceImpl @Inject constructor(private val bbDao: BBDao) : BBLocalDataSource {
    override suspend fun insertAppLifecycleEvent(appLifecycleEventLocal: AppLifecycleEventLocal) {
        bbDao.insertAppLifecycleEvent(appLifecycleEventLocal)
    }

    override fun getAllAppLifecycleEventsFlow(): Flow<List<AppLifecycleEventLocal>> {
        return bbDao.getAllAppLifecycleEventsFlow()
    }

    override suspend fun deleteAppLifecycleEventList(appLifecycleEventLocals: List<AppLifecycleEventLocal>) {
        bbDao.deleteAppLifecycleEventList(appLifecycleEventLocals)
    }

    override suspend fun deleteAllAppLifecycleEvents() {
        bbDao.deleteAllAppLifecycleEvents()
    }

    override suspend fun insertTouchTypeData(touchTypeDataLocal: TouchTypeDataLocal) {
        bbDao.insertTouchTypeData(touchTypeDataLocal)
    }

    override fun getAllTouchTypeDataFlow(): Flow<List<TouchTypeDataLocal>> {
        return bbDao.getAllTouchTypeDataFlow()
    }

    override suspend fun deleteTouchTypeDataList(touchTypeDatumLocals: List<TouchTypeDataLocal>) {
        bbDao.deleteTouchTypeDataList(touchTypeDatumLocals)
    }

    override suspend fun deleteAllTouchTypeData() {
        bbDao.deleteAllTouchTypeData()
    }

    override suspend fun insertKeyPressEvent(keyPressEventLocal: KeyPressEventLocal) {
        bbDao.insertKeyPressEvent(keyPressEventLocal)
    }

    override fun getAllKeyPressEventFlow(): Flow<List<KeyPressEventLocal>> {
        return bbDao.getAllKeyPressEventFlow()
    }

    override suspend fun deleteKeyPressEventList(keyPressEventLocal: List<KeyPressEventLocal>) {
        bbDao.deleteKeyPressEventList(keyPressEventLocal)
    }

    override suspend fun deleteAllKeyPressEvents() {
        bbDao.deleteAllKeyPressEvent()
    }

    override suspend fun insertInputChangeEvent(inputChangeEventLocal: InputChangeEventLocal) {
        bbDao.insertInputChangeEvent(inputChangeEventLocal)
    }

    override fun getAllInputChangeEventFlow(): Flow<List<InputChangeEventLocal>> {
        return bbDao.getAllInputChangeEventFlow()
    }

    override suspend fun deleteInputChangeEventList(inputChangeEventLocal: List<InputChangeEventLocal>) {
        bbDao.deleteInputChangeEventList(inputChangeEventLocal)
    }

    override suspend fun deleteAllInputChangeEvents() {
        bbDao.deleteAllInputChangeEvent()
    }

    override suspend fun insertFocusChangeData(focusChangeDataLocal: FocusChangeDataLocal) {
        bbDao.insertFocusChangeData(focusChangeDataLocal)
    }

    override fun getAllFocusChangeDataFlow(): Flow<List<FocusChangeDataLocal>> {
        return bbDao.getAllFocusChangeDataFlow()
    }

    override suspend fun deleteFocusChangeDataList(focusChangeDatumLocals: List<FocusChangeDataLocal>) {
        bbDao.deleteFocusChangeDataList(focusChangeDatumLocals)
    }

    override suspend fun deleteAllFocusChangeData() {
        bbDao.deleteAllFocusChangeData()
    }

    override suspend fun insertViewPortScrollData(viewPortScrollDataLocal: ViewPortScrollDataLocal) {
        bbDao.insertViewPortScrollData(viewPortScrollDataLocal)
    }

    override fun getAllViewPortScrollDataFlow(): Flow<List<ViewPortScrollDataLocal>> {
        return bbDao.getAllViewPortScrollDataFlow()
    }

    override suspend fun deleteViewPortScrollDataList(viewPortScrollDatumLocals: List<ViewPortScrollDataLocal>) {
        bbDao.deleteViewPortScrollDataList(viewPortScrollDatumLocals)
    }

    override suspend fun deleteAllViewPortScrollData() {
        bbDao.deleteAllViewPortScrollData()
    }

    override suspend fun insertFrameRateEvent(frameRateEventLocal: FrameRateEventLocal) {
        bbDao.insertFrameRateEvent(frameRateEventLocal)
    }

    override fun getAllFrameRateEventFlow(): Flow<List<FrameRateEventLocal>> {
        return bbDao.getAllFrameRateEventFlow()
    }

    override suspend fun deleteFrameRateEventList(frameRateEventLocal: List<FrameRateEventLocal>) {
        bbDao.deleteFrameRateEventList(frameRateEventLocal)
    }

    override suspend fun deleteAllFrameRateEvent() {
        bbDao.deleteAllFrameRateEvent()
    }

    override suspend fun insertAccelerometerData(accelerometerDataLocal: AccelerometerDataLocal) {
        bbDao.insertAccelerometerData(accelerometerDataLocal)
    }

    override fun getAllAccelerometerDataFlow(): Flow<List<AccelerometerDataLocal>> {
        return bbDao.getAllAccelerometerDataFlow()
    }

    override suspend fun deleteAccelerometerDataList(accelerometerDataLocal: List<AccelerometerDataLocal>) {
        bbDao.deleteAccelerometerDataList(accelerometerDataLocal)
    }

    override suspend fun deleteAllAccelerometerData() {
        bbDao.deleteAllAccelerometerData()
    }

    override suspend fun insertGyroscopeData(gyroscopeDataLocal: GyroscopeDataLocal) {
        bbDao.insertGyroscopeData(gyroscopeDataLocal)
    }

    override fun getAllGyroscopeDataFlow(): Flow<List<GyroscopeDataLocal>> {
        return bbDao.getAllGyroscopeDataFlow()
    }

    override suspend fun deleteGyroscopeDataList(gyroscopeDataLocal: List<GyroscopeDataLocal>) {
        bbDao.deleteGyroscopeDataList(gyroscopeDataLocal)
    }

    override suspend fun deleteAllGyroscopeData() {
        bbDao.deleteAllGyroscopeData()
    }
}
