package com.bureau.behavioralbiometrics.di

import com.bureau.base.coroutines.CoroutineContextProvider
import com.bureau.base.coroutines.CoroutineContextProviderImpl
import com.bureau.behavioralbiometrics.data.BBRepository
import com.bureau.behavioralbiometrics.data.BBRepositoryImpl
import com.bureau.behavioralbiometrics.data.local.BBLocalDataSource
import com.bureau.behavioralbiometrics.data.local.BBLocalDataSourceImpl
import com.bureau.behavioralbiometrics.data.remote.BBRemoteDataSource
import com.bureau.behavioralbiometrics.data.remote.BBRemoteDataSourceImpl
import dagger.Binds
import dagger.Module

@Module
interface BBAbstractModule {
    @Binds
    fun bbRepository(bbRepository: BBRepositoryImpl): BBRepository

    @Binds
    fun bbLocalDataSource(bbLocalDataSource: BBLocalDataSourceImpl): BBLocalDataSource

    @Binds
    fun bbRemoteDataSource(bbRemoteDataSourceImpl: BBRemoteDataSourceImpl): BBRemoteDataSource

    @Binds
    fun provideCoroutineContext(coroutineContextProviderImpl: CoroutineContextProviderImpl): CoroutineContextProvider
}
