package com.bureau.behavioralbiometrics.di

import android.app.Application
import com.bureau.base.Environment
import com.bureau.behavioralbiometrics.UserBehaviorCapture
import dagger.BindsInstance
import dagger.Component
import dagger.android.AndroidInjector
import javax.inject.Named

@BBScope
@Component(modules = [BBModule::class, BBAbstractModule::class])
interface BBComponent : AndroidInjector<UserBehaviorCapture> {
    @Component.Factory
    interface Factory {
        fun create(
            @BindsInstance application: Application,
            @BindsInstance environment: Environment,
            @BindsInstance
            @Named(CRED_ID)
            credId: String,
            @BindsInstance
            @Named(SESSION_ID)
            sessionId: String,
            @BindsInstance
            @Named(IS_DEV)
            isDev: Boolean
        ): BBComponent
    }

    fun bbActivityComponent(): BBActivityComponent.Factory
}
