package com.bureau.behavioralbiometrics.focuschangedata.models

import androidx.room.Embedded
import androidx.room.Entity
import androidx.room.PrimaryKey
import com.bureau.behavioralbiometrics.data.remote.protoModels.focusChangeData
import com.bureau.behavioralbiometrics.models.TargetElement
import com.bureau.behavioralbiometrics.utils.ViewUtils

@Entity(tableName = "focus_change_data_table")
data class FocusChangeDataLocal(
    @PrimaryKey(autoGenerate = true) var id: Int = 0,
    val timeStamp: Long,
    val focusChangeType: FocusChangeType,
    @Embedded("targetElement_") val targetElement: TargetElement
)

enum class FocusChangeType {
    FOCUS_GAINED,
    FOCUS_LOST,
    UNKNOWN;
}

fun FocusChangeDataLocal.toFocuChangeData() = focusChangeData {
    determinedAt = timeStamp
    type = focusChangeType.name
    target = ViewUtils.getTarget(targetElement)
}
