package com.bureau.behavioralbiometrics.frameratecollection.models

import androidx.room.Entity
import androidx.room.PrimaryKey
import com.bureau.behavioralbiometrics.data.remote.protoModels.frameRateEvent

@Entity(tableName = "frame_rate_event_table")
data class FrameRateEventLocal(
    @PrimaryKey(autoGenerate = true) var id: Int = 0,
    val timeStamp: Long,
    val frameRate: Float
)

fun FrameRateEventLocal.toFrameRateEvent() = frameRateEvent {
    determinedAt = timeStamp
    framesPerSecond = frameRate
}
