package com.bureau.behavioralbiometrics.keypressTypedata.models

import androidx.room.Embedded
import androidx.room.Entity
import androidx.room.PrimaryKey
import com.bureau.behavioralbiometrics.data.remote.protoModels.inputChangeData
import com.bureau.behavioralbiometrics.models.TargetElement
import com.bureau.behavioralbiometrics.utils.ViewUtils

@Entity(tableName = "input_change_data_table")
data class InputChangeEventLocal(
    @PrimaryKey(autoGenerate = true) var id: Int = 0,
    val timeStamp: Long,
    @Embedded("targetElement_") val targetElement: TargetElement,
    val focus: Boolean,
    val maskedText: String,
    val inputChangeAction: InputChangeAction
)

enum class InputChangeAction {
    CUT,
    COPY,
    PASTE,
    AUTOFILL,
    REPLACEMENT,
    UNKNOWN
}

fun InputChangeEventLocal.toInputChangeData() = inputChangeData {
    determinedAt = timeStamp
    target = ViewUtils.getTarget(targetElement)
    focus = this@toInputChangeData.focus
    maskedText = this@toInputChangeData.maskedText
    truncatedText = false
    action = inputChangeAction.name
}
