package com.bureau.behavioralbiometrics.keypressTypedata.models

import androidx.room.Embedded
import androidx.room.Entity
import androidx.room.PrimaryKey
import com.bureau.behavioralbiometrics.data.remote.protoModels.keyPressData
import com.bureau.behavioralbiometrics.models.TargetElement
import com.bureau.behavioralbiometrics.utils.ViewUtils

@Entity(tableName = "key_press_data_table")
data class KeyPressEventLocal(
    @PrimaryKey(autoGenerate = true) var id: Int = 0,
    val timeStamp: Long,
    val keyPressType: KeyPressType,
    val maskedKey: Int,
    @Embedded("targetElement_") val targetElement: TargetElement
)

enum class KeyPressType {
    KEY_UP,
    KEY_DOWN,
    UNKNOWN
}

fun KeyPressEventLocal.toKeyPressData() = keyPressData {
    determinedAt = timeStamp
    type = keyPressType.name
    specialKey = ""
    maskedKey = this@toKeyPressData.maskedKey
    target = ViewUtils.getTarget(targetElement)
}
