package com.bureau.behavioralbiometrics.sensordata.models

import androidx.room.Entity
import androidx.room.PrimaryKey
import com.bureau.behavioralbiometrics.data.remote.protoModels.AccelerometerData
import com.bureau.behavioralbiometrics.data.remote.protoModels.accelerometerData

@Entity(tableName = "accelerometer_data")
data class AccelerometerDataLocal(
    @PrimaryKey(autoGenerate = true) var id: Int = 0,
    val timeStamp: Long,
    val xAcc: Double,
    val yAcc: Double,
    val zAcc: Double
)

fun AccelerometerDataLocal.toAccelerometerData(): AccelerometerData = accelerometerData {
    determinedAt = timeStamp
    x = xAcc
    y = yAcc
    z = zAcc
}
