package com.bureau.behavioralbiometrics.sensordata.models

import androidx.room.Entity
import androidx.room.PrimaryKey
import com.bureau.behavioralbiometrics.data.remote.protoModels.GyroscopeData
import com.bureau.behavioralbiometrics.data.remote.protoModels.gyroscopeData

@Entity(tableName = "gyroscope_data")
data class GyroscopeDataLocal(
    @PrimaryKey(autoGenerate = true) var id: Int = 0,
    val timeStamp: Long,
    val xRot: Double,
    val yRot: Double,
    val zRot: Double
)

fun GyroscopeDataLocal.toGyroscopeData(): GyroscopeData = gyroscopeData {
    determinedAt = timeStamp
    x = xRot
    y = yRot
    z = zRot
}
