package com.bureau.behavioralbiometrics.touchtypedata.models

import androidx.room.Embedded
import androidx.room.Entity
import androidx.room.PrimaryKey
import com.bureau.behavioralbiometrics.data.remote.protoModels.viewportScrollData
import com.bureau.behavioralbiometrics.models.TargetElement

@Entity(tableName = "view_port_scroll_data_table")
data class ViewPortScrollDataLocal(
    @PrimaryKey(autoGenerate = true) var id: Int = 0,
    val timeStamp: Long,
    val deltaX: Long,
    val deltaY: Long,
    @Embedded("targetElement_") val targetElement: TargetElement
)

fun ViewPortScrollDataLocal.toViewportScrollData() = viewportScrollData {
    determinedAt = timeStamp
    xPosition = deltaX
    yPosition = deltaY
}
